/*
 *    Copyright (C) 2017 Sobey Inc.
 *
 *    This program is free software: you can redistribute it and/or  modify
 *    it under the terms of the GNU Affero General Public License, version 3,
 *    as published by the Free Software Foundation.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Affero General Public License for more details.
 *
 *    You should have received a copy of the GNU Affero General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include "stdafx.h"
#include "SobeyMemDBConfiguration.h"
#include "SobeyMemDBConfigurationDlg.h"
#include "..\VernoxBaseLib\ServerStatusManage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


extern CEvent * g_pEeventStart;
// Ӧó򡰹ڡ˵ CAboutDlg Ի

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Ի
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

// ʵ
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSobeyMemDBConfigurationDlg Ի




CSobeyMemDBConfigurationDlg::CSobeyMemDBConfigurationDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSobeyMemDBConfigurationDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON_VERNOX);


	//ʼ
	m_strEditDatabaseName = _T("Vernox");

	memset(m_lpBaseDir, 0, MAX_PATH * sizeof(TCHAR));
	memset(m_lpWorkingDir, 0, MAX_PATH * sizeof(TCHAR));
	memset(m_lpDataFileDir, 0, MAX_PATH * sizeof(TCHAR));
	memset(m_lpDatabaseDir, 0, MAX_PATH * sizeof(TCHAR));
	memset(m_lpConfigFilePath, 0, MAX_PATH * sizeof(TCHAR));
	//ȡļ·
	GetModuleFileName(NULL, m_lpBaseDir, MAX_PATH);
	(_tcsrchr(m_lpBaseDir, _T('\\')))[1] = 0;
	memcpy(m_lpWorkingDir, m_lpBaseDir, MAX_PATH * sizeof(TCHAR));						//m_lpWorkingDir		..\Vernox\BinX64\	
	(_tcsrchr(m_lpBaseDir, _T('\\')))[0] = 0;
	(_tcsrchr(m_lpBaseDir, _T('\\')))[1] = 0;											//m_lpBaseDir			..\Vernox\							
	_stprintf(m_lpDataFileDir, _T("%sData\\"), m_lpBaseDir);							//m_lpDataFileDir		..\Vernox\Data\			
	_stprintf(m_lpDatabaseDir, _T("%sData\\Vernox\\"), m_lpBaseDir);					//m_lpDatabaseDir		..\Vernox\Data\Vernox\		
	_stprintf(m_lpConfigFilePath, _T("%sVernoxConfig.ini"), m_lpWorkingDir);			//m_lpConfigFilePath	..\Vernox\BinX64\VernoxConfig.ini

	m_bExit = FALSE;
	m_colorBackground = RGB(255, 0, 0);
	m_nProgress = 0;
	m_bFileNO = 0;
	m_pServerStatusManage = NULL;
	
	Sleep(1);
}

CSobeyMemDBConfigurationDlg::~CSobeyMemDBConfigurationDlg()
{
	m_bExit = TRUE;
	g_pEeventStart->SetEvent();
	Sleep(100);
	if(m_pServerStatusManage != NULL)
	{
		delete m_pServerStatusManage;
		m_pServerStatusManage = NULL;
	}
}


void CSobeyMemDBConfigurationDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	//ؼ
	DDX_Control(pDX, IDC_EDIT, m_Edit);
	DDX_Control(pDX, IDC_LIST, m_ListCtrl);
	DDX_Control(pDX, IDC_LIST_DATABASE, m_listboxDatabase);
	DDX_Control(pDX, IDC_PROGRESS, m_ctlProgress);
}

BEGIN_MESSAGE_MAP(CSobeyMemDBConfigurationDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_NOTIFY(NM_DBLCLK, IDC_LIST, &CSobeyMemDBConfigurationDlg::OnNMDblclkList)
	ON_EN_KILLFOCUS(IDC_EDIT, &CSobeyMemDBConfigurationDlg::OnEnKillfocusEdit)
	ON_BN_CLICKED(IDC_BTN_CREATE_DATABASE, &CSobeyMemDBConfigurationDlg::OnBnClickedBtnCreateDatabase)
	ON_BN_CLICKED(IDC_BTN_DELETE_DATABASE, &CSobeyMemDBConfigurationDlg::OnBnClickedBtnDeleteDatabase)
	ON_BN_CLICKED(IDC_BTN_START_DATABASE, &CSobeyMemDBConfigurationDlg::OnBnClickedBtnStartDatabase)
	ON_BN_CLICKED(IDC_BTN_CLOSE_DATABASE, &CSobeyMemDBConfigurationDlg::OnBnClickedBtnCloseDatabase)
	ON_WM_CTLCOLOR()
	ON_WM_TIMER()
END_MESSAGE_MAP()


// CSobeyMemDBConfigurationDlg Ϣ

BOOL CSobeyMemDBConfigurationDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ...˵ӵϵͳ˵С

	// IDM_ABOUTBOX ϵͳΧڡ
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	//////////////////////////////////////////////////////////////////////////
	int nIndex;

	m_Edit.ShowWindow(SW_HIDE);

	//
	m_ListCtrl.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES | LVS_EX_INFOTIP);
	m_ListCtrl.InsertColumn(0, _T(""), LVCFMT_LEFT, 160);
	m_ListCtrl.InsertColumn(1, _T("ֵ"), LVCFMT_LEFT, 300);


	nIndex = m_ListCtrl.InsertItem (0, _T("ݿ"));
	m_ListCtrl.SetItemText (nIndex, 1, _T("Vernox"));

	nIndex = m_ListCtrl.InsertItem (1, _T("ڴļСMB"));
	m_ListCtrl.SetItemText (nIndex, 1, _T("256"));
	nIndex = m_ListCtrl.InsertItem (2, _T("TREEڴļСMB"));
	m_ListCtrl.SetItemText (nIndex, 1, _T("256"));
	nIndex = m_ListCtrl.InsertItem (3, _T("KVڴļСMB"));
	m_ListCtrl.SetItemText (nIndex, 1, _T("128"));

	ShowDatabases(m_lpDataFileDir);

	m_ctlProgress.SetRange(0, 100);
	m_ctlProgress.SetPos(0);

	_beginthread(CheckServiceStatusThread, 0, (void *)this);
	g_pEeventStart->SetEvent();

	return TRUE;  // ǽõؼ򷵻 TRUE
}

void CSobeyMemDBConfigurationDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CSobeyMemDBConfigurationDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡù
//ʾ
HCURSOR CSobeyMemDBConfigurationDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


//////////////////////////////////////////////////////////////////////////
//Զ幦ܺ
void CSobeyMemDBConfigurationDlg::CheckServiceStatusThread(LPVOID lpParam)
{
	CSobeyMemDBConfigurationDlg *pThis;
	pThis = (CSobeyMemDBConfigurationDlg *)lpParam;

	SERVICE_STATUS status;
	SC_HANDLE schSCManager, schService, schStorage;
	BOOL bServiceRunning, bStorageRunning;

	schSCManager = NULL;
	schService = NULL;
	schStorage = NULL;

	bServiceRunning = FALSE;
	bStorageRunning = FALSE;
	pThis->ServiceChangeColor(bServiceRunning);
	pThis->StorageChangeColor(bStorageRunning); 

	schSCManager = OpenSCManager(NULL, NULL, SERVICE_QUERY_STATUS);			// 򿪷ƹݿ⣬طƹݿľ
	if(schSCManager == NULL)
	{
		return;
	}

	while (TRUE)
	{
		//ʼ
		WaitForSingleObject((HANDLE)*g_pEeventStart, 3000);
		if (pThis->m_bExit)
		{
			break;
		} 
		else
		{
			//Service
			if (schService == NULL)
			{
				schService = OpenService(schSCManager, _T("VernoxService"), SERVICE_QUERY_STATUS);	// ÷
			}

			if (schService != NULL)
			{
				if (!QueryServiceStatus(schService, &status))		// ÷ĵǰ״̬
				{
					//ʧ
					CloseServiceHandle(schService);
					schService = NULL;
				}
				else
				{
					if (status.dwCurrentState == SERVICE_STOPPED)		// Ƿֹͣ״̬
					{
						if (bServiceRunning == TRUE)
						{
							bServiceRunning = FALSE;
							pThis->ServiceChangeColor(bServiceRunning);
						}
						CloseServiceHandle(schService);
						schService = NULL;
					}
					else
					{
						if (bServiceRunning == FALSE)
						{
							bServiceRunning = TRUE;
							pThis->ServiceChangeColor(bServiceRunning);
						}
					}
				}
			}

			//Storage
			if (schStorage == NULL)
			{
				schStorage = OpenService(schSCManager, _T("VernoxStorage"), SERVICE_QUERY_STATUS);	// ÷
			}

			if (schStorage != NULL)
			{
				if (!QueryServiceStatus(schStorage, &status))		// ÷ĵǰ״̬
				{
					CloseServiceHandle(schStorage);
					schStorage = NULL;
				}
				else
				{
					if (status.dwCurrentState == SERVICE_STOPPED)		// Ƿֹͣ״̬
					{
						if (bStorageRunning == TRUE)
						{
							bStorageRunning = FALSE;
							pThis->StorageChangeColor(bStorageRunning);
						}
						CloseServiceHandle(schStorage);
						schStorage = NULL;
					}
					else
					{
						if (bStorageRunning == FALSE)
						{
							bStorageRunning = TRUE;
							pThis->StorageChangeColor(bStorageRunning);
						}
					}
				}
			}
		}

		if (pThis->m_bExit)
		{
			break;
		}
	}

	
	if (schService != NULL)
	{
		CloseServiceHandle(schService);
		schService = NULL;
	}
	if (schStorage != NULL)
	{
		CloseServiceHandle(schStorage);
		schStorage = NULL;
	}
	if (schSCManager != NULL)
	{
		CloseServiceHandle(schSCManager);
		schSCManager = NULL;
	}
	return;
}


BOOL CSobeyMemDBConfigurationDlg::CreateNewDatabase()
{
	int nRet;
	int nDataFileSize, nTreeFileSize, nKVFileSize;
	LONGLONG llSystemFileSize;
	CString strText, strValue;
	TCHAR lpFilePath[MAX_PATH];

	memset(lpFilePath, 0, MAX_PATH * sizeof(TCHAR));

	m_strEditDatabaseName = m_ListCtrl.GetItemText(0, 1);		//ݿ
	_stprintf(m_lpDatabaseDir, _T("%s%s\\"), m_lpDataFileDir, m_strEditDatabaseName);

	WritePrivateProfileString(_T("System"), _T("databasename"), m_strEditDatabaseName, m_lpConfigFilePath);
	WritePrivateProfileString(_T("System"), _T("databasepath"), m_lpDatabaseDir, m_lpConfigFilePath);


	strValue = m_ListCtrl.GetItemText(1, 1);		//ڴļСMB
	strValue.Trim();
	if (strValue == strValue.SpanIncluding(_T("0123456789")))
	{
		nDataFileSize = _ttoi(strValue);
	}
	else
	{
		strValue = m_ListCtrl.GetItemText(1, 0);
		strText.Format(_T("%sҪΪ֣"), strValue);
		CMessageBox(strText);
		goto CreateNewDatabase_End;
	}
	strValue = m_ListCtrl.GetItemText(2, 1);		//TREEڴļСMB
	strValue.Trim();
	if (strValue == strValue.SpanIncluding(_T("0123456789")))
	{
		nTreeFileSize = _ttoi(strValue);
	}
	else
	{
		strValue = m_ListCtrl.GetItemText(2, 0);
		strText.Format(_T("%sҪΪ֣"), strValue);
		CMessageBox(strText);
		goto CreateNewDatabase_End;
	}
	strValue = m_ListCtrl.GetItemText(3, 1);		//KVڴļСMB
	strValue.Trim();
	if (strValue == strValue.SpanIncluding(_T("0123456789")))
	{
		nKVFileSize = _ttoi(strValue);
	}
	else
	{
		strValue = m_ListCtrl.GetItemText(3, 0);
		strText.Format(_T("%sҪΪ֣"), strValue);
		CMessageBox(strText);
		goto CreateNewDatabase_End;
	}
	m_ctlProgress.SetPos(2);
	//ļ
	nRet = _taccess_s(m_lpDataFileDir, 0);
	if (nRet != 0)
	{
		_tmkdir(m_lpDataFileDir);
	}
	_stprintf(lpFilePath, _T("%s%s\\"), m_lpDataFileDir, m_strEditDatabaseName);
	nRet = _taccess_s(lpFilePath, 0);
	if (nRet != 0)
	{
		_tmkdir(lpFilePath);
		//ϵͳļ
		llSystemFileSize = 8*1024*1024;
		nRet = CreateSystemDataFile(llSystemFileSize);
		m_ctlProgress.SetPos(4);
		if (nRet != 0)
		{
			strText.Format(_T("ϵͳļʧܣ룺%d"), nRet);
			CMessageBox(strText);
			goto CreateNewDatabase_End;
		}
	}
	else
	{
		strText.Format(_T("ݿ%sѴڣ"), m_strEditDatabaseName);
		CMessageBox(strText);
		goto CreateNewDatabase_End;	
	}


	nRet = SobeyMemInstallService(_T("VernoxStorage"));
	m_ctlProgress.SetPos(7);
	if (nRet != 0)
	{
		strText.Format(_T("VernoxStorageʧܣ룺%d"), nRet);
		CMessageBox(strText);
		goto CreateNewDatabase_End;
	}

	nRet = SobeyMemInstallService(_T("VernoxService"));
	m_ctlProgress.SetPos(9);
	if (nRet != 0)
	{
		strText.Format(_T("VernoxServiceʧܣ룺%d"), nRet);
		CMessageBox(strText);
		goto CreateNewDatabase_End;
	}

	//ļ
	nRet = CreateDataFile(nDataFileSize, nTreeFileSize, nKVFileSize);
	if (nRet != 0)
	{
		strText.Format(_T("ļʧܣ룺%d"), nRet);
		CMessageBox(strText);
		goto CreateNewDatabase_End;
	}

	ShowDatabases(m_lpDataFileDir);
	m_ctlProgress.SetPos(100);

	strText.Format(_T("ݿ%sɹ"), m_strEditDatabaseName);
	CMessageBox(strText);
	return TRUE;

CreateNewDatabase_End:
	ShowDatabases(m_lpDataFileDir);
	return FALSE;
}

void CSobeyMemDBConfigurationDlg::DeleteDatabase()
{
	int nRet, nCurSel;
	CString strText, strValue;
	TCHAR lpFilePath[MAX_PATH];

	memset(lpFilePath, 0, MAX_PATH * sizeof(TCHAR));

	nCurSel = m_listboxDatabase.GetCurSel();
	if (nCurSel < 0)
	{
		CMessageBox(_T("ѡҪɾݿ⣡"));
		return;
	}

	m_listboxDatabase.GetText(nCurSel, strValue);
	strText.Format(_T("ǷҪɾݿ %s "), strValue);
	if (IDYES != CMessageBox(strText, MB_YESNO|MB_SYSTEMMODAL))
	{
		return;
	}

	m_strEditDatabaseName = strValue;
	_stprintf(m_lpDatabaseDir, _T("%s%s\\"), m_lpDataFileDir, m_strEditDatabaseName);


	nRet = _taccess_s(m_lpDatabaseDir, 0);
	if (nRet != 0)
	{
		strText.Format(_T("ݿ%sڣ"), m_strEditDatabaseName);
		CMessageBox(strText);
		return;
	}

	//ɾ
	nRet = SobeyMemDeleteService(_T("VernoxService"));
	if (nRet != 0 && nRet != ERROR_SERVICE_DOES_NOT_EXIST)
	{
		strText.Format(_T("ɾVernoxServiceʧܣ룺%d"), nRet);
		CMessageBox(strText);
		return;
	}
	nRet = SobeyMemDeleteService(_T("VernoxStorage"));
	if (nRet != 0 && nRet != ERROR_SERVICE_DOES_NOT_EXIST)
	{
		strText.Format(_T("ɾVernoxStorageʧܣ룺%d"), nRet);
		CMessageBox(strText);
		return;
	}


	//ɾļ
	nRet = DeleteDirectory(m_lpDatabaseDir);
	if (nRet != 0)
	{
		strText.Format(_T("ɾݿ%sļʧܣ룺%dݿ·%s"), m_strEditDatabaseName, nRet, m_lpDatabaseDir);
		CMessageBox(strText);
		return;
	}

	strText.Format(_T("ɾݿ%sɹݿ·%s"), m_strEditDatabaseName, m_lpDatabaseDir);
	CMessageBox(strText);

	ShowDatabases(m_lpDataFileDir);

	return;
}

int CSobeyMemDBConfigurationDlg::DeleteDirectory(LPCTSTR lpFilePath) 
{
	int nRet, nCount;
	CFileFind ccFileFind;
	TCHAR lpFileFind[MAX_PATH], lpFoundFileName[MAX_PATH], lpFoundFilePath[MAX_PATH];

	memset(lpFileFind, 0, MAX_PATH * sizeof(TCHAR));
	memset(lpFoundFileName, 0, MAX_PATH * sizeof(TCHAR));
	memset(lpFoundFilePath, 0, MAX_PATH * sizeof(TCHAR));

	_stprintf(lpFileFind, _T("%s\\*.*"), lpFilePath);
	BOOL IsFinded = (BOOL)ccFileFind.FindFile(lpFileFind);
	while(IsFinded)
	{
		IsFinded = (BOOL)ccFileFind.FindNextFile();
		if(!ccFileFind.IsDots())
		{
			_tcscpy(lpFoundFileName, ccFileFind.GetFileName().GetBuffer(MAX_PATH));
			if(ccFileFind.IsDirectory())
			{
				_stprintf(lpFoundFilePath, _T("%s\\%s"), lpFilePath, lpFoundFileName);
				nRet = DeleteDirectory(lpFoundFilePath);
				if (nRet != 0)
				{
					ccFileFind.Close();
					return nRet;
				}
			}
			else
			{
				_stprintf(lpFoundFilePath, _T("%s\\%s"), lpFilePath, lpFoundFileName);
				nCount = 0;
				while (TRUE)
				{
					if (DeleteFile(lpFoundFilePath))
					{
						break;
					} 
					else
					{
						nRet = GetLastError();
						if (nRet == ERROR_SHARING_VIOLATION)
						{
							if (nCount > 1000)		//10s
							{
								ccFileFind.Close();
								return nRet;
							}
							nCount++;
							Sleep(10);
							continue;
						} 
						else
						{
							ccFileFind.Close();
							return nRet;
						}
					}
				}
			}
		}
	}

	ccFileFind.Close();
	if(!RemoveDirectory(lpFilePath))
	{
		return GetLastError();
	}
	return MF_OK;
}

void CSobeyMemDBConfigurationDlg::CloseDatabase()
{
	int nRet;
	CString strText;
	//رշ
	if(SobeyMemCheckService(_T("VernoxService")))
	{
		nRet = SobeyMemDeleteService(_T("VernoxService"), 1);
		if (nRet != 0)
		{
			strText.Format(_T("رշVernoxServiceʧܣ룺%d"), nRet);
			CMessageBox(strText);
			return;
		}
	}
	if(SobeyMemCheckService(_T("VernoxStorage")))
	{
		nRet = SobeyMemDeleteService(_T("VernoxStorage"), 1);
		if (nRet != 0)
		{
			strText.Format(_T("رշVernoxStorageʧܣ룺%d"), nRet);
			CMessageBox(strText);
			return;
		}
	}

	CMessageBox(_T("ݿرճɹ"));
}

void CSobeyMemDBConfigurationDlg::StartServiceThread(LPVOID data)
{
	CSobeyMemDBConfigurationDlg *pDlg = (CSobeyMemDBConfigurationDlg *)data;
	CoInitialize(NULL);
	try
	{
		if(pDlg->m_pServerStatusManage != NULL)
		{
			delete pDlg->m_pServerStatusManage;
			pDlg->m_pServerStatusManage = NULL;
		}
		//аť״̬û
		pDlg->GetDlgItem(IDC_BTN_CREATE_DATABASE)->EnableWindow(FALSE);
		pDlg->GetDlgItem(IDC_BTN_CLOSE_DATABASE)->EnableWindow(FALSE);
		pDlg->GetDlgItem(IDC_BTN_START_DATABASE)->EnableWindow(FALSE);
		pDlg->GetDlgItem(IDC_BTN_DELETE_DATABASE)->EnableWindow(FALSE);
		//
		pDlg->StartServiceCore();
		if(pDlg->m_pServerStatusManage != NULL)
		{
			delete pDlg->m_pServerStatusManage;
			pDlg->m_pServerStatusManage = NULL;
		}
	}
	catch (...)
	{
	}
	g_pEeventStart->SetEvent();
	//аť״̬ÿ
	pDlg->GetDlgItem(IDC_BTN_CREATE_DATABASE)->EnableWindow(TRUE);
	pDlg->GetDlgItem(IDC_BTN_CLOSE_DATABASE)->EnableWindow(TRUE);
	pDlg->GetDlgItem(IDC_BTN_START_DATABASE)->EnableWindow(TRUE);
	pDlg->GetDlgItem(IDC_BTN_DELETE_DATABASE)->EnableWindow(TRUE);
	CoUninitialize();
	_endthread();
}

void CSobeyMemDBConfigurationDlg::StartServiceCore()
{
	CString strText;
	int nRet, nCurSel;
	TCHAR lpDstPath[MAX_PATH], lpSrcPath[MAX_PATH];

	nCurSel = m_listboxDatabase.GetCurSel();
	if (nCurSel < 0)
	{
		return;
	}

	m_ctlProgress.SetPos(0);
	m_listboxDatabase.GetText(nCurSel, m_strEditDatabaseName);
	_stprintf(m_lpDatabaseDir, _T("%s%s\\"), m_lpDataFileDir, m_strEditDatabaseName);
	_stprintf(lpDstPath, _T("%sVernoxConfig.ini"), m_lpWorkingDir);			//ļ·
	_stprintf(lpSrcPath, _T("%sVernoxConfig.ini"), m_lpDatabaseDir);		//ļ·
	CopyFile(lpSrcPath, lpDstPath, FALSE);

	WritePrivateProfileString(_T("System"), _T("databasename"), m_strEditDatabaseName, m_lpConfigFilePath);
	WritePrivateProfileString(_T("System"), _T("databasepath"), m_lpDatabaseDir, m_lpConfigFilePath);
	//־ûǷ
	if(SobeyMemCheckService(_T("VernoxStorage")))
	{
	}
	else
	{
		nRet = SobeyMemStorgeInstallService();
		if(nRet == -1)
		{
			TCHAR lpPath[MAX_PATH];
			memset(lpPath, 0, sizeof(lpPath));
			_stprintf(lpPath, _T("%sVernoxStorage.exe"), m_lpWorkingDir);
			if(_taccess(lpPath, 0) == -1)
			{
				strText.Format(_T("־ûעʧܣԭļ[%s]ڣ"), lpPath);
			}
			else
			{
				strText.Format(_T("־ûעʧܣԭļ[%s]޷У"), lpPath);
			}
			CMessageBox(strText);
			return;
		}
		else if(nRet != MF_OK)
		{

			TCHAR lpPath[MAX_PATH];
			memset(lpPath, 0, sizeof(lpPath));
			_stprintf(lpPath, _T("%sVernoxStorage.exe"), m_lpWorkingDir);
			if(_taccess(lpPath, 0) == -1)
			{
				strText.Format(_T("־ûļ[%s]޷ʣ"), lpPath);
				CMessageBox(strText);
				return;
			}
			else
			{
				strText.Format(_T("ݿ%s־ûʧܣֵ%d"), m_strEditDatabaseName, nRet);
				CMessageBox(strText);
				return;
			}
		}
	}

	m_ctlProgress.SetPos(90);
	//Ƿ
	if(SobeyMemCheckService(_T("VernoxService")))
	{
	}
	else
	{
		nRet = SobeyMemServiceInstallService();
		if(nRet != MF_OK)
		{
			strText.Format(_T("ݿ%sʧܣֵ%d"), m_strEditDatabaseName, nRet);
			CMessageBox(strText);
			return;
		}
	}

	m_ctlProgress.SetPos(100);
	strText.Format(_T("ݿ%sɹ"), m_strEditDatabaseName);
	CMessageBox(strText);
}

void CSobeyMemDBConfigurationDlg::StartDatabase()
{
	int nCurSel;

	nCurSel = m_listboxDatabase.GetCurSel();
	if (nCurSel < 0)
	{
		CMessageBox(_T("ѡҪݿ⣡"));
		return;
	}
	_beginthread(StartServiceThread, 0, (void *)this);
}


BOOL CSobeyMemDBConfigurationDlg::SobeyMemCheckService(LPCTSTR lpServiceName)
{
	SERVICE_STATUS status;
	SC_HANDLE schSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);			// 򿪷ƹݿ⣬طƹݿľ
	if(schSCManager == NULL)
	{
		return FALSE;
	}
	SC_HANDLE schService = OpenService(schSCManager, lpServiceName, SERVICE_ALL_ACCESS | DELETE);	// ÷
	if(schService == NULL)
	{
		CloseServiceHandle(schSCManager);				// رշ
		return FALSE;
	}
	if (!QueryServiceStatus(schService, &status))		// ÷ĵǰ״̬
	{
		//ʧ
		CloseServiceHandle(schSCManager);				// رշ
		CloseServiceHandle(schService);
		return FALSE;
	}

	if (status.dwCurrentState == SERVICE_STOPPED)		// Ƿֹͣ״̬
	{
		CloseServiceHandle(schSCManager);				// رշ
		CloseServiceHandle(schService); 
		return FALSE;
	}
	else
	{
		CloseServiceHandle(schSCManager);					// رշ
		CloseServiceHandle(schService); 
		return TRUE;
	}
}

int CSobeyMemDBConfigurationDlg::SobeyMemInstallService(LPCTSTR lpServiceName)
{
	BOOL bInstall;
	int nRet, nCount;
	SERVICE_STATUS ssStatus; 
	SC_HANDLE shMyService, shServiceManager;
	try
	{
		// 򿪷ƹ
		bInstall = FALSE;
		shServiceManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
		if (shServiceManager == NULL)
		{
			return GetLastError();
		}
		// 򿪷
		shMyService = OpenService(shServiceManager, lpServiceName, SERVICE_ALL_ACCESS);
		if(shMyService == NULL)
		{
			nRet = GetLastError();
			if (nRet == ERROR_SERVICE_DOES_NOT_EXIST)
			{
InstallService_Label:
				//ע
				STARTUPINFO si;
				PROCESS_INFORMATION pi;
				TCHAR lpPath[MAX_PATH];

				bInstall = TRUE;
				ZeroMemory(&pi, sizeof(pi));
				ZeroMemory(&si, sizeof(si));
				si.cb = sizeof(si);
				memset(lpPath, 0, MAX_PATH * sizeof(TCHAR));

				_stprintf(lpPath, _T("%s%s.exe"), m_lpWorkingDir, lpServiceName);
				CreateProcess(lpPath, _T("-Service"), NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
				Sleep(200);
				if(pi.hProcess == NULL)
				{
					return -1;
				}

				nCount = 0;
				while(TRUE)
				{
					shMyService = OpenService(shServiceManager, lpServiceName, SERVICE_ALL_ACCESS);
					if(shMyService != NULL)
						break;
					if(WaitForSingleObject(pi.hProcess, 16) == WAIT_OBJECT_0)
					{
						break;
					}
					//40Ӿͷ
					if(nCount > 4000)
					{
						break;
					}
					nCount++;
				}
				CloseHandle( pi.hProcess );
				CloseHandle( pi.hThread );
				if(shMyService == NULL)
				{
					//Ϣʧ
					CloseServiceHandle(shServiceManager);
					return GetLastError();
				}
			} 
			else
			{
				return nRet;
			}	
		}



		if (!QueryServiceStatus(shMyService, &ssStatus)) //ѯصǰService״̬
		{
			CloseServiceHandle(shMyService);
			CloseServiceHandle(shServiceManager);
			return GetLastError();
		}

		if(ssStatus.dwCurrentState == SERVICE_STOPPED)
		{
			if (!StartService(shMyService, 0, NULL))
			{
				CloseServiceHandle(shMyService);
				CloseServiceHandle(shServiceManager);
				return GetLastError();
			}

			Sleep(100);
			//ʼѯ
			nCount = 0;
			while(TRUE)
			{
				QueryServiceStatus(shMyService, &ssStatus);
				if(ssStatus.dwCurrentState == SERVICE_RUNNING)
				{
					break;
				}
				else if(ssStatus.dwCurrentState == SERVICE_STOPPED)
				{
					if(bInstall)
					{
						CloseServiceHandle(shMyService);
						CloseServiceHandle(shServiceManager);
						return MF_FAILED;
					}
					else
					{
						DeleteService(shMyService);
						CloseServiceHandle(shMyService);
						CloseServiceHandle(shServiceManager);
						goto InstallService_Label;
					}
				}
				Sleep(100);
				//1Ӿͷ
				if(nCount > 600)
				{
					break;
				}
			}
		}
		else
		{
			CloseServiceHandle(shMyService);
			CloseServiceHandle(shServiceManager);
			return ERROR_SERVICE_ALREADY_RUNNING;
		}
		CloseServiceHandle(shMyService);
		CloseServiceHandle(shServiceManager);
		return MF_OK;
	}
	catch(...)
	{
		return MF_INNER_EXPCETION_FAILED;
	}
	return MF_OK;
}


//ɾͣ
//nMode == 0 ɾ
//nMode != 0 ͣ
int CSobeyMemDBConfigurationDlg::SobeyMemDeleteService(LPCTSTR lpServiceName, int nMode)
{
	int nCount;
	SERVICE_STATUS status;
	SC_HANDLE schSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);			// 򿪷ƹݿ⣬طƹݿľ
	if(schSCManager == NULL)
	{
		return GetLastError();
	}
	SC_HANDLE schService = OpenService(schSCManager, lpServiceName, SERVICE_ALL_ACCESS | DELETE);	// ÷
	if(schService == NULL)
	{
		CloseServiceHandle(schSCManager);				// رշ
		return MF_OK;
	}
	if (!QueryServiceStatus(schService, &status))		// ÷ĵǰ״̬
	{
		//ʧ
		CloseServiceHandle(schSCManager);				// رշ
		CloseServiceHandle(schService);
		return GetLastError();
	} 			
	if (status.dwCurrentState != SERVICE_STOPPED)		// 񲻴ֹͣ״̬״̬Ϊֹͣ״̬
	{
		if (!ControlService(schService, SERVICE_CONTROL_STOP, &status))
		{
			//ʧ
			int nError = GetLastError();
			if (nError == ERROR_DEPENDENT_SERVICES_RUNNING)
			{
				Sleep(1000);
				if (!ControlService(schService, SERVICE_CONTROL_STOP, &status))
				{
					CloseServiceHandle(schSCManager);			// رշ
					CloseServiceHandle(schService);
					return GetLastError();
				}
			}
			else
			{
				CloseServiceHandle(schSCManager);			// رշ
				CloseServiceHandle(schService);
				return nError;
			}
		}

		//ʼѯ
		nCount = 0;
		while(TRUE)
		{
			QueryServiceStatus(schService, &status);
			if(status.dwCurrentState == SERVICE_STOPPED)
			{
				break;
			}
			Sleep(100);
			//1Ӿͷ
			if(nCount > 600)
			{
				break;
			}
		}
	}
	if (nMode == 0)
	{
		if (!DeleteService(schService))					// ɾ
		{
			//ʧ
			CloseServiceHandle(schSCManager);			// رշ
			CloseServiceHandle(schService);
			return GetLastError();
		}		
	}
	CloseServiceHandle(schSCManager);					// رշ
	CloseServiceHandle(schService); 
	return MF_OK;
}

int CSobeyMemDBConfigurationDlg::CreateSystemDataFile(LONGLONG llSystemFileSize)
{
	HANDLE hFile;
	LONGLONG nPos;
	LPBYTE lpBuffer;
	DWORD dwBufSize;
	long long nTimestamp;
	int nBufferSize, nRet;
	TCHAR lpFilePath[MAX_PATH], lpStrParamValue[MAX_PATH];

	memset(lpFilePath, 0, MAX_PATH * sizeof(TCHAR));
	memset(lpStrParamValue, 0, MAX_PATH * sizeof(TCHAR));

	nBufferSize = 8*1024*1024;
	lpBuffer = new BYTE[nBufferSize];
	memset(lpBuffer, 0, nBufferSize);

	GetPrivateProfileString(_T("System"), _T("systemfile"), _T("System.dbf"), lpStrParamValue, MAX_PATH, m_lpConfigFilePath);


	//Ҫ½ļ
	_stprintf(lpFilePath, _T("%s%s"), m_lpDatabaseDir, lpStrParamValue);
	hFile = CreateFile(lpFilePath, 
		GENERIC_READ|GENERIC_WRITE, 
		FILE_SHARE_READ, 
		NULL, 
		CREATE_NEW, 
		FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN, 
		NULL);
	if (hFile == INVALID_HANDLE_VALUE)
	{
		//½ļʧ
		delete[] lpBuffer;
		return GetLastError();
	}

	//дļͷ
	m_lpSystemFileHead = (LPSYSTEMFILEHEAD)lpBuffer;
	m_lpFileAddr	   = lpBuffer;
	ReadSysConfigParam(m_lpSystemFileHead, llSystemFileSize);

	GetSystemTimeAsFileTime((LPFILETIME)&nTimestamp);
	nRet = CreateSystemObject(MF_SYS_OBJECTTYPE_DUAL, nTimestamp);
	if(nRet != MF_OK)
	{
		return nRet;
	}
	nRet = CreateSystemObject(MF_SYS_OBJECTTYPE_FILE, nTimestamp);
	if(nRet != MF_OK)
	{
		return nRet;
	}
	nRet = CreateSystemObject(MF_SYS_OBJECTTYPE_OBJECT, nTimestamp);
	if(nRet != MF_OK)
	{
		return nRet;
	}
	nRet = CreateSystemObject(MF_SYS_OBJECTTYPE_INDEX, nTimestamp);
	if(nRet != MF_OK)
	{
		return nRet;
	}
	nRet = CreateSystemObject(MF_SYS_OBJECTTYPE_SEQUENCE, nTimestamp);
	if(nRet != MF_OK)
	{
		return nRet;
	}
	nRet = CreateSystemObject(MF_SYS_OBJECTTYPE_STATISTICS, nTimestamp);
	if(nRet != MF_OK)
	{
		return nRet;
	}
	nRet = CreateSystemObject(MF_SYS_OBJECTTYPE_SESSION, nTimestamp);
	if(nRet != MF_OK)
	{
		return nRet;
	}
	nRet = CreateSystemObject(MF_SYS_OBJECTTYPE_SOAPSERVER, nTimestamp);
	if(nRet != MF_OK)
	{
		return nRet;
	}
	nRet = CreateSystemObject(MF_SYS_OBJECTTYPE_USERINFO, nTimestamp);
	if(nRet != MF_OK)
	{
		return nRet;
	}
	nRet = CreateSystemObject(MF_SYS_OBJECTTYPE_AUTHORITY, nTimestamp);
	if(nRet != MF_OK)
	{
		return nRet;
	}

	if(!WriteFile(hFile, lpBuffer, nBufferSize, &dwBufSize, NULL))
	{
		//дʧ
		delete[] lpBuffer;
		return GetLastError();
	}

	//дʼļ
	memset(lpBuffer, 0, nBufferSize);
	for(nPos = dwBufSize; nPos < llSystemFileSize; nPos += dwBufSize)
	{
		if(llSystemFileSize - nPos > nBufferSize)
		{
			if(!WriteFile(hFile, lpBuffer, nBufferSize, &dwBufSize, NULL))
			{
				//дʧ
				delete[] lpBuffer;
				return GetLastError();
			}
		}
		else
		{
			if(!WriteFile(hFile, lpBuffer, (DWORD)(llSystemFileSize - nPos), &dwBufSize, NULL))
			{
				//дʧ
				delete[] lpBuffer;
				return GetLastError();
			}
		}
	}

	FlushFileBuffers(hFile);
	CloseHandle(hFile);
	delete[] lpBuffer;
	return MF_OK;
}

int CSobeyMemDBConfigurationDlg::CreateDataFile(int nDataFileSize, int nTreeFileSize, int nKVFileSize)
{
	ULONG ulIP;
	USHORT usPort;
	char pStrSql[1024];
	int nRet, lAffectCount;
	CString strSql, strText;
	CDBInterface* pSobeyInterface;
	MF_EXECUTE_STATISTICS stStatisticsInfo;
	
	m_nTotalSize = nDataFileSize + nTreeFileSize + nKVFileSize;
	if(m_nTotalSize == 0)
	{
		return MF_OK;
	}

	ulIP = ntohl(inet_addr("127.0.0.1"));
	usPort = 8000;
	pSobeyInterface = new CDBInterface;
	nRet = pSobeyInterface->OpenWithAddress("root", "", ulIP, usPort);
	if (nRet != MF_OK)
	{
		strText.Format(_T("ӷʧܣIPַ%d.%d.%d.%d:%d, 룺%d"), 
			FIRST_IPADDRESS(ulIP), SECOND_IPADDRESS(ulIP), THIRD_IPADDRESS(ulIP), FOURTH_IPADDRESS(ulIP), usPort, nRet);
		CMessageBox(strText);
		goto CreateDataFile_Release;
	}

	m_ctlProgress.SetPos(10);
	m_nProgress = 10;
	SetTimer(100, 200, NULL);
	nRet = MF_OK;
	memset(pStrSql, 0, sizeof(pStrSql));

	if (nDataFileSize > 0)
	{
		memset(&stStatisticsInfo, 0, sizeof(MF_EXECUTE_STATISTICS));
		strSql.Format(_T("ALTER SYSTEM ADD DATAFILE '%sDBDataFile.dbf' MEMFILE 'MemDBDataFile' %dMB"), m_lpDatabaseDir, nDataFileSize);
		WideCharToMultiByte(CP_UTF8, 0, strSql, strSql.GetLength()+1, pStrSql, 1024, NULL, NULL);
		nRet = pSobeyInterface->ExecuteCommand(pStrSql, lAffectCount, &stStatisticsInfo);
		if (nRet != MF_OK)
		{
			strText.Format(_T("ļʧܣֵ%d룺%dSQL䣺%s"), nRet, stStatisticsInfo.m_nRet, strSql);
			CMessageBox(strText);
			goto CreateDataFile_Release;
		}
		m_nProgress = 10 + nDataFileSize * 90.0/m_nTotalSize;
		m_ctlProgress.SetPos(m_nProgress);
	}
	
	if (nTreeFileSize > 0)
	{
		memset(&stStatisticsInfo, 0, sizeof(MF_EXECUTE_STATISTICS));
		strSql.Format(_T("ALTER SYSTEM ADD TREEFILE '%sDBTreeFile.dbf' MEMFILE 'MemDBTreeFile' %dMB"), m_lpDatabaseDir, nTreeFileSize);
		WideCharToMultiByte(CP_UTF8, 0, strSql, strSql.GetLength()+1, pStrSql, 1024, NULL, NULL);
		nRet = pSobeyInterface->ExecuteCommand(pStrSql, lAffectCount, &stStatisticsInfo);
		if (nRet != MF_OK)
		{
			strText.Format(_T("ļʧܣֵ%d룺%dSQL䣺%s"), nRet, stStatisticsInfo.m_nRet, strSql);
			CMessageBox(strText);
			goto CreateDataFile_Release;
		}
		m_nProgress = 10 + (nDataFileSize + nTreeFileSize) * 90.0/m_nTotalSize;
		m_ctlProgress.SetPos(m_nProgress);
	}
	
	if (nKVFileSize > 0)
	{
		memset(&stStatisticsInfo, 0, sizeof(MF_EXECUTE_STATISTICS));
		strSql.Format(_T("ALTER SYSTEM ADD KVFILE '%sDBKVFile.dbf' MEMFILE 'MemDBKVFile' %dMB"), m_lpDatabaseDir, nKVFileSize);
		WideCharToMultiByte(CP_UTF8, 0, strSql, strSql.GetLength()+1, pStrSql, 1024, NULL, NULL);
		nRet = pSobeyInterface->ExecuteCommand(pStrSql, lAffectCount, &stStatisticsInfo);
		if (nRet != MF_OK)
		{
			strText.Format(_T("ļʧܣֵ%d룺%dSQL䣺%s"), nRet, stStatisticsInfo.m_nRet, strSql);
			CMessageBox(strText);
			goto CreateDataFile_Release;
		}
		m_nProgress = 10 + (nDataFileSize + nTreeFileSize + nKVFileSize) * 90.0/m_nTotalSize;
		m_ctlProgress.SetPos(m_nProgress);
	}

CreateDataFile_Release:
	m_nProgress = 0;
	KillTimer(100);
	Sleep(1);
	if (pSobeyInterface != NULL)
	{
		delete pSobeyInterface;
	}
	return nRet;
}

//ϵͳ
int CSobeyMemDBConfigurationDlg::CreateSystemObject(int nSysObjectID, long long nTimestamp)
{
	CString strMsg;
	long long nDataOffset;
	LPSYSTEMBLOCKHEAD lpSystemBlockHead;
	LPBASEFILEBLOCKMAP lpBaseFileBlockMap;
	LPBASEFILEBLOCKMAPHEAD lpBaseFileBlockMapHead;

	if(m_lpSystemFileHead->m_stuFileObjectData[nSysObjectID].m_nID == 0)
	{
		//ȡп飬ڲϵͳ
		m_lpSystemFileHead->m_stuFileObjectData[nSysObjectID].m_nID	= nSysObjectID;
		m_lpSystemFileHead->m_stuFileObjectData[nSysObjectID].m_nFinishedTimestamp = 0;
		if(m_lpSystemFileHead->m_stuFileObjectData[nSysObjectID].m_nFreeBlockMapOffset == 0)
		{
			//¿
			if(nSysObjectID > 0 && nSysObjectID < 100)
			{
				//µĿп
				//ȼһǷ˵һ
				if(m_lpSystemFileHead->m_nBlockNum == 0)
				{
					//ʼӦóʼһЩ
					m_lpSystemFileHead->m_nBlockMapStructSize	= sizeof(BASEFILEBLOCKMAP);
					m_lpSystemFileHead->m_nBlockMapStartOffset	= m_lpSystemFileHead->m_nFileHeaderSize;			//ͷṹ֮
					//޸
					m_lpSystemFileHead->m_nFileFreePos			= MF_SYS_BLOCKSIZE;							//256KBλÿʼдݣǰ256KBļͷʹðɣļչӽ4GBңȫʹò
					m_lpSystemFileHead->m_nFileFreeSize			= m_lpSystemFileHead->m_nFileTotalSize - m_lpSystemFileHead->m_nFileFreePos;
					lpBaseFileBlockMapHead						= (LPBASEFILEBLOCKMAPHEAD)(m_lpFileAddr + m_lpSystemFileHead->m_nBlockMapStartOffset);
					memset(lpBaseFileBlockMapHead, 0, sizeof(BASEFILEBLOCKMAPHEAD));
				}

				//жǷпտ飬оֱʹÿտ
				if(m_lpSystemFileHead->m_nFreeBlockOffset != 0)
				{
					AfxMessageBox(_T("½ϵͳʱϵͳļдڿտ飡"));
					return MF_INNER_SYS_OBJECTMAP_DATAERROR;
				}
				else
				{
					//жϿռǷ
					if(m_lpSystemFileHead->m_nFileFreePos + MF_SYS_BLOCKSIZE > m_lpSystemFileHead->m_nFileTotalSize)
					{
						//ʣռ䲻
						strMsg.Format(_T("ݿʱʣռ䲻ļС%lldǰλã%lldҪĿռСΪ%d"), m_lpSystemFileHead->m_nFileTotalSize, m_lpSystemFileHead->m_nFileFreePos, MF_SYS_BLOCKSIZE);
						AfxMessageBox(strMsg);
						return MF_INNER_ALLOWBLOCK_NOENOUGHSPACE;
					}

					//һռ
					lpBaseFileBlockMapHead = (LPBASEFILEBLOCKMAPHEAD)(m_lpFileAddr + m_lpSystemFileHead->m_nBlockMapStartOffset);
					lpBaseFileBlockMap	= &lpBaseFileBlockMapHead->m_pBlockMap[lpBaseFileBlockMapHead->m_nBlockMapNum];
					nDataOffset			= m_lpSystemFileHead->m_nBlockMapStartOffset + sizeof(BASEFILEBLOCKMAPHEAD) + (lpBaseFileBlockMapHead->m_nBlockMapNum - 1)*sizeof(BASEFILEBLOCKMAP);

					//ӳݣ޸Ӧָ
					lpBaseFileBlockMap->m_nBlockOffset		= m_lpSystemFileHead->m_nFileFreePos;
					lpBaseFileBlockMap->m_nBlockNo			= m_lpSystemFileHead->m_nInnerMaxNo;
					m_lpSystemFileHead->m_nInnerMaxNo++;
					m_lpSystemFileHead->m_nFileFreePos		= m_lpSystemFileHead->m_nFileFreePos + MF_SYS_BLOCKSIZE;
					m_lpSystemFileHead->m_nFileFreeSize		= m_lpSystemFileHead->m_nFileTotalSize - m_lpSystemFileHead->m_nFileFreePos;

					//ݿṹ
					lpSystemBlockHead						= (LPSYSTEMBLOCKHEAD)(m_lpFileAddr + lpBaseFileBlockMap->m_nBlockOffset);
					lpSystemBlockHead->m_nDataFlag			= MAKEHEADFLAG('S','B','D','B');
					lpSystemBlockHead->m_nBlockNo			= lpBaseFileBlockMap->m_nBlockNo;
					lpSystemBlockHead->m_nBlockSize			= MF_SYS_BLOCKSIZE;
					lpSystemBlockHead->m_nBlockHeadSize		= sizeof(SYSTEMBLOCKHEAD);
					lpSystemBlockHead->m_bStatus			= 0;
					lpSystemBlockHead->m_bFileNo			= m_lpSystemFileHead->m_bFileNo;
					lpSystemBlockHead->m_nObjectID			= nSysObjectID;
					lpSystemBlockHead->m_nInnerMaxNo		= 0;
					lpSystemBlockHead->m_nDataInsertOffset	= lpSystemBlockHead->m_nBlockHeadSize;
					lpSystemBlockHead->m_nVarDataInsertOffset= MF_SYS_BLOCKSIZE;
					lpSystemBlockHead->m_nDataNum			= 0;
					if(nSysObjectID == MF_SYS_OBJECTTYPE_FILE)
					{
						lpSystemBlockHead->m_nBlockDataStructSize = sizeof(FILE_MEMDBFILEINFO);
					}
					else if(nSysObjectID == MF_SYS_OBJECTTYPE_OBJECT)
					{
						lpSystemBlockHead->m_nBlockDataStructSize = sizeof(SYSTEMBLOCKDATASTRUCT);
					}
					else if(nSysObjectID == MF_SYS_OBJECTTYPE_INDEX)
					{
						lpSystemBlockHead->m_nBlockDataStructSize = sizeof(FILE_INDEXDEF);
					}
					else if(nSysObjectID == MF_SYS_OBJECTTYPE_SEQUENCE)
					{
						lpSystemBlockHead->m_nBlockDataStructSize = sizeof(FILE_SEQUENCEDEF);
					}
					else if(nSysObjectID == MF_SYS_OBJECTTYPE_USERINFO)
					{
						lpSystemBlockHead->m_nBlockDataStructSize = sizeof(FILE_USERINFO);
					}
					else if(nSysObjectID == MF_SYS_OBJECTTYPE_AUTHORITY)
					{
						lpSystemBlockHead->m_nBlockDataStructSize = sizeof(FILE_AUTHORITY);
					}
					else
					{
						//Ŀǰδǣʱͳһɶ
						lpSystemBlockHead->m_nBlockDataStructSize = sizeof(SYSTEMBLOCKDATASTRUCT);
					}

					//뵽
					lpBaseFileBlockMap->m_nNextOffset = m_lpSystemFileHead->m_stuFileObjectData[nSysObjectID].m_nFreeBlockMapOffset;
					m_lpSystemFileHead->m_stuFileObjectData[nSysObjectID].m_nFreeBlockMapOffset = nDataOffset;
					lpBaseFileBlockMapHead->m_nBlockMapNum++;
					m_lpSystemFileHead->m_nBlockNum++;

					lpSystemBlockHead->m_bSaveFlag		= 0;
					lpSystemBlockHead->m_nTimestamp		= nTimestamp;
					m_lpSystemFileHead->m_nTimestamp	= nTimestamp;

					Sleep(1);
				}
			}
			if(nSysObjectID == MF_SYS_OBJECTTYPE_USERINFO)
			{
				LPFILE_USERINFO lpFileUser;
				if(lpSystemBlockHead == NULL)
				{
					AfxMessageBox(_T("ROOTûʱʧܣδֺʵĿ飡"));
					return MF_INNER_POINTER_NULL;
				}
				else if(sizeof(LPFILE_USERINFO) >= lpSystemBlockHead->m_nVarDataInsertOffset - lpSystemBlockHead->m_nDataInsertOffset)
				{
					//ռ䲻㣬ӦãΪʱж˵ģһ¶жԷ©֮
					AfxMessageBox(_T("ROOTûʱʧܣڿռ䲻㣡"));
					return MF_FAILED;
				}
				else
				{
					lpFileUser								= (LPFILE_USERINFO)(((LPBYTE)lpSystemBlockHead) + lpSystemBlockHead->m_nDataInsertOffset);
					lpFileUser->m_nInnerNo					= lpSystemBlockHead->m_nInnerMaxNo;								
					lpFileUser->m_nUserID					= MakeDataID(MF_SYS_FILETYPE_SYSFILE, lpSystemBlockHead->m_nBlockNo, lpFileUser->m_nInnerNo);
					lpFileUser->m_bStatus					= 1;
					memcpy(lpFileUser->m_pUserName, "root", 24);
					memset(lpFileUser->m_pPassword, 0, 24);
					lpFileUser->m_bAuthorityID[MF_AUTHORITY_DBA] = 1;
			
					lpSystemBlockHead->m_nDataInsertOffset	+= lpSystemBlockHead->m_nBlockDataStructSize;
					lpSystemBlockHead->m_nDataNum++;
					lpSystemBlockHead->m_nInnerMaxNo++;

					lpSystemBlockHead->m_nTimestamp = nTimestamp;
				}
			}
			else if(nSysObjectID == MF_SYS_OBJECTTYPE_AUTHORITY)
			{
				//ΪȨޱռȨ
				int nRet;
				nRet = AddAuthority(MF_AUTHORITY_DBA, "DBA", _T("ԱȨ"), nTimestamp);
				if(nRet != MF_OK)
				{
					AfxMessageBox(_T("ϵͳʱȨʧܣȨDBA"));
					return nRet;
				}
				nRet = AddAuthority(MF_AUTHORITY_ALTERSYSTEM, "ALTERSYSTEM", _T("ϵͳ޸Ȩ"), nTimestamp);
				if(nRet != MF_OK)
				{
					AfxMessageBox(_T("ϵͳʱȨʧܣȨALTERSYSTEM"));
					return nRet;
				}
				nRet = AddAuthority(MF_AUTHORITY_CREATEOBJECT, "CREATEOBJECT", _T("Ȩ"), nTimestamp);
				if(nRet != MF_OK)
				{
					AfxMessageBox(_T("ϵͳʱȨʧܣȨCREATEOBJECT"));
					return nRet;
				}
				nRet = AddAuthority(MF_AUTHORITY_ALTEROBJECT, "ALTEROBJECT", _T("޸ĶȨ"), nTimestamp);
				if(nRet != MF_OK)
				{
					AfxMessageBox(_T("ϵͳʱȨʧܣȨALTEROBJECT"));
					return nRet;
				}
				nRet = AddAuthority(MF_AUTHORITY_DROPOBJECT, "DROPOBJECT", _T("ɾȨ"), nTimestamp);
				if(nRet != MF_OK)
				{
					AfxMessageBox(_T("ϵͳʱȨʧܣȨDROPOBJECT"));
					return nRet;
				}
				nRet = AddAuthority(MF_AUTHORITY_CREATESEQUENCE, "CREATESEQUENCE", _T("Ȩ"), nTimestamp);
				if(nRet != MF_OK)
				{
					AfxMessageBox(_T("ϵͳʱȨʧܣȨCREATESEQUENCE"));
					return nRet;
				}
				nRet = AddAuthority(MF_AUTHORITY_DROPSEQUENCE, "DROPSEQUENCE", _T("ɾȨ"), nTimestamp);
				if(nRet != MF_OK)
				{
					AfxMessageBox(_T("ϵͳʱȨʧܣȨDROPSEQUENCE"));
					return nRet;
				}
			}	
		}
		else
		{
			AfxMessageBox(_T("ϵͳʱ½Ѵڿ飡"));
			return MF_INNER_SYS_OBJECTMAP_DATAERROR;
		}
	}
	else
	{
		//
		AfxMessageBox(_T("ϵͳʱӦĶʹãIDΪ%d"));
		return MF_INNER_SYS_OBJECTMAP_DATAERROR;
	}

	return MF_OK;
}

int CSobeyMemDBConfigurationDlg::AddAuthority(MF_AUTHORITY_ID bAuthorityID, char* pAuthorityName, TCHAR* pDescribe, long nTimestamp)
{
	char* pDesc;
	CString strMsg;
	long long nDataOffset;
	LPFILE_AUTHORITY lpFileAuthority;
	LPSYSTEMBLOCKHEAD lpSystemBlockHead;
	LPBASEFILEBLOCKMAP lpBaseFileBlockMap;
	int nVarLength, nActualVarLen, nLen;
	try
	{
		//䳤ݷ䳤ȣ32
		nActualVarLen  = sizeof(FILE_AUTHORITY);
		nVarLength	   = nActualVarLen + sizeof(SYSTEMBLOCKVARDATASTRUCT);

		//ȡһп
		if(m_lpSystemFileHead->m_stuFileObjectData[MF_SYS_OBJECTTYPE_AUTHORITY].m_nID == MF_SYS_OBJECTTYPE_AUTHORITY)
		{
			//ȡп飬ڲϵͳ
			m_lpSystemFileHead->m_stuFileObjectData[MF_SYS_OBJECTTYPE_AUTHORITY].m_nFinishedTimestamp = 0;
			nDataOffset = m_lpSystemFileHead->m_stuFileObjectData[MF_SYS_OBJECTTYPE_AUTHORITY].m_nFreeBlockMapOffset;

			lpBaseFileBlockMap = (LPBASEFILEBLOCKMAP)(m_lpFileAddr + nDataOffset);
			lpSystemBlockHead  = (LPSYSTEMBLOCKHEAD)(m_lpFileAddr + lpBaseFileBlockMap->m_nBlockOffset);
			//ռ䣬Ƿ
			if(lpSystemBlockHead->m_nVarDataInsertOffset - lpSystemBlockHead->m_nDataInsertOffset <= nVarLength + sizeof(SYSTEMBLOCKDATASTRUCT))
			{
				strMsg.Format(_T("Ȩʱַصݿʣռ䲻Ȩ%s"), pAuthorityName);
				AfxMessageBox(strMsg);
			}
		}
		else
		{
			strMsg.Format(_T("ȨʱȨ޶ΪգȨ%s"), pAuthorityName);
			AfxMessageBox(strMsg);
		}

		//ȱUserϢ
		pDesc = CConvertToUTF8(pDescribe, nLen);
		lpFileAuthority						    = (LPFILE_AUTHORITY)(((LPBYTE)lpSystemBlockHead) + lpSystemBlockHead->m_nDataInsertOffset);
		lpFileAuthority->m_bAuthorityID			= bAuthorityID;
		memcpy(lpFileAuthority->m_pAuthorityName, pAuthorityName, 32);
		memcpy(lpFileAuthority->m_pAuthorityDesc, pDesc, nLen);
		delete [] pDesc;

		lpSystemBlockHead->m_nDataInsertOffset	+= lpSystemBlockHead->m_nBlockDataStructSize;
		lpSystemBlockHead->m_nDataNum++;
	}
	catch (...)
	{
		strMsg.Format(_T("Ȩʱδ֪쳣Ȩ%s룺%d"), pAuthorityName, GetLastError());
		AfxMessageBox(strMsg);
		return MF_INNER_EXPCETION_FAILED;
	}
	return MF_OK;
}


//ݿΨһʶ
USHORT CSobeyMemDBConfigurationDlg::CreateDatabaseGuid()
{
	GUID guid;
	USHORT usGuid;

	::CoCreateGuid(&guid);
	memcpy(&usGuid, &guid, sizeof(usGuid));
	return usGuid;
}

//ȡļϵͳ
//ļΪgbk
//
//[Init]			ʼȺĹϵݲ޸
//[System]			ϵͳ޸ģÿʱ
void CSobeyMemDBConfigurationDlg::ReadSysConfigParam(LPSYSTEMFILEHEAD lpSystemFileHead, LONGLONG llSystemFileSize)
{
	UINT nParamValue;
	DWORD dwSize = MAX_PATH;
	char lpStrA[MAX_PATH];
	const TCHAR* lpAppName = _T("System");
	TCHAR lpStrParamValue[MAX_PATH];

	memset(lpStrA, 0, MAX_PATH);
	memset(lpStrParamValue, 0, MAX_PATH * sizeof(TCHAR));

	nParamValue = GetPrivateProfileInt(lpAppName, _T("soapprocesses"), 20, m_lpConfigFilePath);
	GetPrivateProfileString(lpAppName, _T("standbyip"), _T(""), lpStrParamValue, dwSize, m_lpConfigFilePath);

	lpSystemFileHead->m_nDataFlag					= MAKEHEADFLAG('S', 'B', 'S', 'F');
	lpSystemFileHead->m_bFileNo						= 1;					//ļ
	lpSystemFileHead->m_nTimestamp					= 0;					//ļʱ
	lpSystemFileHead->m_bStatus						= 0;					//ڴļ״̬
	lpSystemFileHead->m_usDatabaseGuid				= CreateDatabaseGuid();		//ݿΨһʶ
	lpSystemFileHead->m_nFileTotalSize				= llSystemFileSize;			//ļС
	lpSystemFileHead->m_nFileHeaderSize				= sizeof(SYSTEMFILEHEAD);							//ļͷС
	lpSystemFileHead->m_nBlockNum					= 0;												//
	lpSystemFileHead->m_nBlockMapStructSize			= sizeof(BASEFILEBLOCKMAP);							//ӳеĴС
	lpSystemFileHead->m_nBlockMapStartOffset		= lpSystemFileHead->m_nFileHeaderSize;				//ӳ׵ַƫƣλļͷ
	lpSystemFileHead->m_nBlockStartOffset			= 256*1024;//256KBλÿʼдݡʼַ
	lpSystemFileHead->m_nFileFreePos				= 256*1024;//256KBλÿʼдݡпռ׵ַļʱΪʼλ
	lpSystemFileHead->m_nFileFreeSize				= lpSystemFileHead->m_nFileTotalSize - lpSystemFileHead->m_nFileFreePos;	//пռ׵ַļСȥпռ׵ַ
	lpSystemFileHead->m_nInnerMaxNo					= 1;		//ֵڲʱ
	lpSystemFileHead->m_nObjectMaxID				= 100;		//IDOBJECTʱʹãǰ100ΪϵͳԤԴֵʼֵΪ100
	lpSystemFileHead->m_nRedoLogMaxID				= 1;
	lpSystemFileHead->m_bFileMaxNo					= 2;		//ļֵ¼ļʹãעΪ1ıʾϵͳļ
	lpSystemFileHead->m_bSysTimeChange				= 0;		//ϵͳʱ仯0ʾȫ1ʾʱı䣬2ʾʱǰı
	lpSystemFileHead->m_bFileCMD					= 0;		//VernoxStorage.exeִ½ļ0ʾκδ1ڴļ󣨾½ڱļڲļУ32ڴļĴ󣬷յ״̬޸Ϊ0
	lpSystemFileHead->m_bReservedByte				= 10;
	lpSystemFileHead->m_nBeginTimestamp				= 0;		//ļ޸ĵĿʼʱVernoxStorage.exe޸ģһαļôֵ൱ڸдļ̣ҪעСʱ
	lpSystemFileHead->m_nEndTimestamp				= 0;		//ļ޸ĵĽʱɱ̸ά޸ģÿһ޸ʱдֵÿдʱǷСڴʱ޸оͲд©дҲVernoxStorage.exeд̵ʱ
	lpSystemFileHead->m_nFreeBlockOffset			= 0;

	GetPrivateProfileString(lpAppName, _T("databasename"), _T("Vernox"), lpStrParamValue, dwSize, m_lpConfigFilePath);
	WideCharToMultiByte(CP_UTF8, 0, lpStrParamValue, -1, lpSystemFileHead->m_cDatabaseName, MAX_PATH, NULL, NULL);
	GetPrivateProfileString(lpAppName, _T("databasepath"), _T("c:\\SobeyMemDB\\Data\\Vernox\\"), lpStrParamValue, dwSize, m_lpConfigFilePath);
	WideCharToMultiByte(CP_UTF8, 0, lpStrParamValue, -1, lpSystemFileHead->m_cDatabasePath, MAX_PATH, NULL, NULL);
	lpSystemFileHead->m_nServicePort				= GetPrivateProfileInt(lpAppName, _T("soapport"), 8080, m_lpConfigFilePath);				//SERVICE_PORT Web Serviceļ˿ڣĬΪ8080
	lpSystemFileHead->m_nServiceWorkers				= GetPrivateProfileInt(lpAppName, _T("processes"), 500, m_lpConfigFilePath);				//SERVICE_WORKERS Web Serviceķ߳ĬΪ10
	GetPrivateProfileString(lpAppName, _T("listenip"), _T("0.0.0.0"), lpStrParamValue, dwSize, m_lpConfigFilePath);
	WideCharToMultiByte(CP_UTF8, 0, lpStrParamValue, -1, lpStrA, MAX_PATH, NULL, NULL);
	lpSystemFileHead->m_nTCPListenIP				= ntohl(inet_addr(lpStrA));																	//TCP_LISTEN_IPTCPIPַĬΪ0ʾ
	lpSystemFileHead->m_nTCPListenPort				= GetPrivateProfileInt(lpAppName, _T("listenport"), 8000, m_lpConfigFilePath);				//TCP_LISTEN_PORTTCP˿ڣĬΪ8000
	lpSystemFileHead->m_nTCPTimeout					= 60;                   //TCP_TIMEOUT TCPͼݳʱʱ䣬ĬΪ60룻
	lpSystemFileHead->m_nServerTraceLevel			= 10;                   //SERVER_TRACE_LEVELϵͳ־ȼĬΪ10
	lpSystemFileHead->m_nServerEfficiencyTrace		= 0;					//SERVER_EFFICIENCY_TRACEϵͳЧ־ĬΪ0
	lpSystemFileHead->m_nServerParallelMode			= 0;                    //SERVER_PARALLELMODEģʽ0дӰ죬1зʽִУ
	lpSystemFileHead->m_nServerWriteUndoMode		= 1;                    //SERVER_WRITE_UNDOMODE д־ģʽ(ĬΪ1)0д1д
	lpSystemFileHead->m_nServerExecuteTimeMonitor	= 5000;                  //SERVER_EXECUTETIME_MONITORִʱأڸSQLܣĬ5000
	lpSystemFileHead->m_nServerCaseSensitive		= GetPrivateProfileInt(lpAppName, _T("charcomparenocase"), 0, m_lpConfigFilePath);			//SERVER_CASE_SENSITIVEַСдǷУ0ΪС1ΪУĬΪ0
	//ݶΧ8MB~1.99GB
	lpSystemFileHead->m_nMemoryTemporarySize		= GetPrivateProfileInt(lpAppName, _T("temporaryareasize"), 256, m_lpConfigFilePath);		//MEMORY_TEMPORARY_SIZEʱڴС(ݼʹ)λΪMBĬ48
	if (lpSystemFileHead->m_nMemoryTemporarySize < 8 || lpSystemFileHead->m_nMemoryTemporarySize > 2047)
	{
		lpSystemFileHead->m_nMemoryTemporarySize = 256;
	}
	lpSystemFileHead->m_nMemoryTemporarySize = lpSystemFileHead->m_nMemoryTemporarySize*1024*1024;
	//ݶΧ8MB~1.99GB
	lpSystemFileHead->m_nMemoryUndoSize				= GetPrivateProfileInt(lpAppName, _T("undoareasize"), 256, m_lpConfigFilePath);				//MEMORY_UNDO_SIZEڴСݻعһԶȡʹãĬ48MB
	if (lpSystemFileHead->m_nMemoryUndoSize < 8 || lpSystemFileHead->m_nMemoryUndoSize > 2047)
	{
		lpSystemFileHead->m_nMemoryUndoSize = 256;
	}
	lpSystemFileHead->m_nMemoryUndoSize = lpSystemFileHead->m_nMemoryUndoSize*1024*1024;
	//ݶΧ1MB~128MB
	lpSystemFileHead->m_nMemoryProcessSize			= GetPrivateProfileInt(lpAppName, _T("processprivatearea"), 2, m_lpConfigFilePath);			//MEMORY_PROCESS_SIZE߳˽ڴСͻͨѶĬ2MB 
	if (lpSystemFileHead->m_nMemoryProcessSize < 1 || lpSystemFileHead->m_nMemoryProcessSize > 128)
	{
		lpSystemFileHead->m_nMemoryProcessSize = 2;
	}
	lpSystemFileHead->m_nMemoryProcessSize = lpSystemFileHead->m_nMemoryProcessSize*1024*1024;
	lpSystemFileHead->m_nMemoryPlanRemainSize		= 10*1024;              //MEMORY_PLAN_REMAINSIZEִмƻռСĬ10KB
	lpSystemFileHead->m_nMemorySQLPlanMaxSize		= 10*1024*1024;         //MEMORY_SQLPLAN_MAXSIZESQLִмƻСĬ10MB
	lpSystemFileHead->m_nMemoryRecordsetPlanMaxSize	= 500*1024*1024;        //MEMORY_RECORDSETPLAN_MAXSIZEִмƻСĬ500MB
	lpSystemFileHead->m_nWriteFileDelayTime			= 3;                    //WRITE_FILE_DELAY_TIMEдļӳʱ䣬ĬΪ3룻
	lpSystemFileHead->m_nWriteUndoDelayTime			= 3;                    //WRITE_UNDO_DELAY_TIMEд־ļӳʱ䣬ĬΪ3룻
	lpSystemFileHead->m_nWriteTraceDelayTime		= 3;                    //WRITE_TRACE_DELAY_TIMEд־ļӳʱ䣬ĬΪ3룻
	lpSystemFileHead->m_nWriteUndoMaxSize			= 50*1024*1024;         //WRITE_UNDO_MAX_SIZE ־ļС
	lpSystemFileHead->m_nWriteTraceMaxSize			= 50*1024*1024;         //WRITE_TRACE_MAX_SIZE ־ļС
	lpSystemFileHead->m_nBlockDataSize				= 1*1024*1024;          //BLOCK_DATA_SIZEݿĴСĬΪ1MB
	lpSystemFileHead->m_nBlockBTreeIndexSize		= 32*1024;              //BLOCK_BTREE_INDEX_SIZEBСĬΪ32KB
	lpSystemFileHead->m_nBlockBTreeDataSize			= 32*1024;              //BLOCK_BTREE_DATA_SIZEBݿСĬΪ32KB(Ϊ)
	lpSystemFileHead->m_nBlockHashIndexSize			= 256*1024;             //BLOCK_HASH_INDEX_SIZEHASHСĬΪ256KB
	lpSystemFileHead->m_nBlockHashIndexChainMaxSize	= 8;                    //BLOCK_HASH_INDEX_CHAIN_MAXSIZEϣ󳤶ȣ˳ȾԶӹϣĻλȣĬΪ8
	lpSystemFileHead->m_nBlockHashIndexExpandRatio	= 4;                    //BLOCK_HASH_INDEX_EXPAND_RATIOϣĻλʣĬΪ4
	lpSystemFileHead->m_nBlockUsedRatio				= 80;                   //BLOCK_USED_RATIO ݿʹʣﵽֵʾѾдĬΪ80
	lpSystemFileHead->m_nBlockInsertMaxUseRatio		= 90;					//BLOCK_INSERT_MAXUSE_RATIOʹʣֵ룬ĬΪ90
	lpSystemFileHead->m_nBlockFreeRatio				= 40;                   //BLOCK_FREE_RATIO ݿʣʣɾݺʣʵڴֵãĬΪ40
	lpSystemFileHead->m_nBlockReorganizeRatio		= 80;                   //BLOCK_REORGANIZE_RATIO ݿʣﵽֵʱԤУĬΪ80
	lpSystemFileHead->m_nBlockRecycleRatio			= 10;                   //BLOCK_RECYCLE_RATIOݿʣﵽֵʱ飬ĬΪ10
	lpSystemFileHead->m_nBlockIndexDivideMode		= 1;                    //BLOCK_INDEX_DIVIDE_MODE ѷʽ1ʾһķʽзѣ2ʾվűһıʷѣ3ʾһȾŵıʷѣ
	lpSystemFileHead->m_nObjectTransactionMaxNum    = 4;					//OBJECT_TRANSACTION_MAXNUM:ֵ֧
	lpSystemFileHead->m_nTransactionLogicSlotCount	= 100;				    //TRANSACTION_LOGIC_SLOT_COUNT:λĬ100
	lpSystemFileHead->m_nTransactionLogicTimeout	= 60;				    //TRANSACTION_LOGIC_TIMEOUT:Чʱ䣬λΪ룬Ĭ60
	lpSystemFileHead->m_nActiveLogFiles				= GetPrivateProfileInt(lpAppName, _T("activelogfiles"), 20, m_lpConfigFilePath);					//ACTIVE_LOG_FILES־Ĭ20
	lpSystemFileHead->m_nPersistenceIntervals		= GetPrivateProfileInt(lpAppName, _T("persistenceintervals"), 3, m_lpConfigFilePath);				//PERSISTENCE_INTERVALS־ûʱλ룩ɽг־ûĬ3

	memset(lpSystemFileHead->m_bReservedParameter, 0, sizeof(lpSystemFileHead->m_bReservedParameter));         //
}


//ʾеݿ
void CSobeyMemDBConfigurationDlg::ShowDatabases(LPCTSTR lpDataPath)
{
	CFileFind ccFileFind;
	TCHAR lpFileFind[MAX_PATH], lpFoundFileName[MAX_PATH];

	m_listboxDatabase.ResetContent();

	memset(lpFileFind, 0, MAX_PATH * sizeof(TCHAR));
	memset(lpFoundFileName, 0, MAX_PATH * sizeof(TCHAR));

	_stprintf(lpFileFind, _T("%s\\*.*"), lpDataPath);
	BOOL IsFinded = (BOOL)ccFileFind.FindFile(lpFileFind);
	while(IsFinded)
	{
		IsFinded = (BOOL)ccFileFind.FindNextFile();
		if(!ccFileFind.IsDots())
		{
			_tcscpy(lpFoundFileName, ccFileFind.GetFileName().GetBuffer(MAX_PATH));
			if(ccFileFind.IsDirectory())
			{
				m_listboxDatabase.AddString(lpFoundFileName);
			}
		}
	}

	m_listboxDatabase.SetCurSel(0);
	ccFileFind.Close();
}



//////////////////////////////////////////////////////////////////////////

//˫޸ListCtrl
void CSobeyMemDBConfigurationDlg::OnNMDblclkList(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<NMITEMACTIVATE*>(pNMHDR);
	// TODO: ڴӿؼ֪ͨ

	NM_LISTVIEW* pNMListView=(NM_LISTVIEW*)pNMHDR;
	CRect rc;
	m_nRow = pNMListView->iItem;//ѡе  
	m_nCol = pNMListView->iSubItem;//ѡ  

	if   (pNMListView->iSubItem != 0) //ѡ;  
	{  
		m_ListCtrl.GetSubItemRect(m_nRow,m_nCol,LVIR_LABEL,rc);//RECT  
		m_Edit.SetParent(&m_ListCtrl);//תΪбе  
		m_Edit.MoveWindow(rc);//ƶEditRECTڵλ;  
		m_Edit.SetWindowText(m_ListCtrl.GetItemText(m_nRow,m_nCol));//еֵEditؼУ  
		m_Edit.ShowWindow(SW_SHOW);//ʾEditؼ  
		m_Edit.SetFocus();//Edit  
		m_Edit.ShowCaret();//ʾ  
		m_Edit.SetSel(-1);//ƶ  
	}

	*pResult = 0;
}

void CSobeyMemDBConfigurationDlg::OnEnKillfocusEdit()
{
	// TODO: ڴӿؼ֪ͨ
	CString tem;  
	m_Edit.GetWindowText(tem);    //õûµ  
	m_ListCtrl.SetItemText(m_nRow,m_nCol,tem);   //ñ༭  
	m_Edit.ShowWindow(SW_HIDE);                //Ӧر༭ 
}

void CSobeyMemDBConfigurationDlg::OnBnClickedBtnCreateDatabase()
{
	_beginthread(CreateDatabaseThread, 0, (void *)this);
}

void CSobeyMemDBConfigurationDlg::OnBnClickedBtnDeleteDatabase()
{
	CWaitCursor cur;
	DeleteDatabase();
	g_pEeventStart->SetEvent();
}

void CSobeyMemDBConfigurationDlg::OnBnClickedBtnStartDatabase()
{
	StartDatabase();
}

void CSobeyMemDBConfigurationDlg::OnBnClickedBtnCloseDatabase()
{
	CWaitCursor cur;
	CloseDatabase();
	g_pEeventStart->SetEvent();
}

void CSobeyMemDBConfigurationDlg::OnCancel()
{
	int nRet;
	nRet = MessageBox(_T("ȷ˳ݿùߣ"), _T("ʾ"), MB_OKCANCEL);
	if(nRet != IDOK)
	{
		return;
	}

	CDialog::OnCancel();
}

void CSobeyMemDBConfigurationDlg::OnOK()
{
	//CDialog::OnOK();
}

HBRUSH CSobeyMemDBConfigurationDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

	if(pWnd-> GetDlgCtrlID()==IDC_STATIC_STORAGE_STATUS || pWnd-> GetDlgCtrlID()==IDC_STATIC_SERVICE_STATUS) 
	{ 
		pDC->SetBkColor(m_colorBackground);
	}

	return hbr;
}

//״̬ɫл
void CSobeyMemDBConfigurationDlg::ServiceChangeColor(BOOL bRunning)
{
	if (bRunning)
	{
		m_colorBackground = RGB(0, 255, 0);
		GetDlgItem(IDC_STATIC_SERVICE_STATUS)->SetWindowText(_T("Service"));
		GetDlgItem(IDC_STATIC_SERVICE_STATUS)->RedrawWindow();
	} 
	else
	{
		m_colorBackground = RGB(255, 0, 0);
		GetDlgItem(IDC_STATIC_SERVICE_STATUS)->SetWindowText(_T("Serviceͣ"));
		GetDlgItem(IDC_STATIC_SERVICE_STATUS)->RedrawWindow();
	}
}

void CSobeyMemDBConfigurationDlg::StorageChangeColor(BOOL bRunning)
{
	if (bRunning)
	{
		m_colorBackground = RGB(0, 255, 0);
		GetDlgItem(IDC_STATIC_STORAGE_STATUS)->SetWindowText(_T("Storage"));
		GetDlgItem(IDC_STATIC_STORAGE_STATUS)->RedrawWindow();
	} 
	else
	{
		m_colorBackground = RGB(255, 0, 0);
		GetDlgItem(IDC_STATIC_STORAGE_STATUS)->SetWindowText(_T("Storageͣ"));
		GetDlgItem(IDC_STATIC_STORAGE_STATUS)->RedrawWindow();
	}
}

int CSobeyMemDBConfigurationDlg::SobeyMemStorgeInstallService()
{
	BOOL bInstall;
	int nRet, nCount;
	SERVICE_STATUS ssStatus; 
	SC_HANDLE shMyService, shServiceManager;
	try
	{
		// 򿪷ƹ
		bInstall = FALSE;
		shServiceManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
		if (shServiceManager == NULL)
		{
			return GetLastError();
		}
		// 򿪷
		shMyService = OpenService(shServiceManager, _T("VernoxStorage"), SERVICE_ALL_ACCESS);
		if(shMyService == NULL)
		{
			nRet = GetLastError();
			if (nRet == ERROR_SERVICE_DOES_NOT_EXIST)
			{
StorgeInstallService_Lable:
				//ע
				STARTUPINFO si;
				PROCESS_INFORMATION pi;
				TCHAR lpPath[MAX_PATH];

				bInstall = TRUE;
				ZeroMemory(&pi, sizeof(pi));
				ZeroMemory(&si, sizeof(si));
				si.cb = sizeof(si);
				memset(lpPath, 0, MAX_PATH * sizeof(TCHAR));

				_stprintf(lpPath, _T("%sVernoxStorage.exe"), m_lpWorkingDir);
				CreateProcess(lpPath, _T("-Service"), NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
				Sleep(200);
				if(pi.hProcess == NULL)
				{
					return -1;
				}

				nCount = 0;
				while(TRUE)
				{
					shMyService = OpenService(shServiceManager, _T("VernoxStorage"), SERVICE_ALL_ACCESS);
					if(shMyService != NULL)
						break;
					if(WaitForSingleObject(pi.hProcess, 16) == WAIT_OBJECT_0)
					{
						break;
					}
					//1Ӿͷ
					if(nCount > 4000)
					{
						break;
					}
					nCount++;
				}


				CloseHandle( pi.hProcess );
				CloseHandle( pi.hThread );
				if(shMyService == NULL)
				{
					//Ϣʧ
					CloseServiceHandle(shServiceManager);
					return GetLastError();
				}
			} 
			else
			{
				return nRet;
			}	
		}

		if (!QueryServiceStatus(shMyService, &ssStatus)) //ѯصǰService״̬
		{
			CloseServiceHandle(shMyService);
			CloseServiceHandle(shServiceManager);
			return GetLastError();
		}

		if(ssStatus.dwCurrentState != SERVICE_RUNNING)
		{
			double dblProgress;
			CServerStatusManage statusManage;
			long long nTotalFileSize, nLoadFileSize;

			dblProgress = 10.0;
			nTotalFileSize = 0;
			nLoadFileSize = 0;
			StartService(shMyService, 0, NULL);
			Sleep(100);
			nCount = 0;
			while(TRUE)
			{
				nRet = statusManage.Initialize();
				if(nRet == MF_OK)
				{
					break;
				}

				Sleep(16);
				QueryServiceStatus(shMyService, &ssStatus);
				if(ssStatus.dwCurrentState == SERVICE_STOPPED)
				{
					if(bInstall)
					{
						CloseServiceHandle(shMyService);
						CloseServiceHandle(shServiceManager);
						return MF_FAILED;
					}
					else
					{
						DeleteService(shMyService);
						CloseServiceHandle(shMyService);
						CloseServiceHandle(shServiceManager);
						goto StorgeInstallService_Lable;
					}
				}
				//1Ӿͷ
				if(nCount > 4000)
				{
					//ʧ
					CloseServiceHandle(shMyService);
					CloseServiceHandle(shServiceManager);
					return MF_FAILED;
				}
				nCount++;
			}
			Sleep(1);

			//ʼѯ
			while(TRUE)
			{
				nRet = statusManage.GetProgressStatus(dblProgress, nTotalFileSize, nLoadFileSize);
				if(nRet == MF_OK)
				{
					m_ctlProgress.SetPos(dblProgress);
				}

				if(abs(dblProgress - 90.0) < 0.05)
				{
					//
					break;
				}
				QueryServiceStatus(shMyService, &ssStatus);
				if(ssStatus.dwCurrentState == SERVICE_RUNNING)
				{
					break;
				}
				else if(ssStatus.dwCurrentState == SERVICE_STOPPED)
				{
					return MF_FAILED;
				}
				Sleep(100);
			}
		}

		CloseServiceHandle(shMyService);
		CloseServiceHandle(shServiceManager);
		return MF_OK;
	}
	catch(...)
	{
		return MF_INNER_EXPCETION_FAILED;
	}
	return MF_OK;
}


int CSobeyMemDBConfigurationDlg::SobeyMemServiceInstallService()
{
	BOOL bInstall;
	int nRet, nCount;
	SERVICE_STATUS ssStatus; 
	SC_HANDLE shMyService, shServiceManager;
	try
	{
		// 򿪷ƹ
		bInstall = FALSE;
		shServiceManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
		if (shServiceManager == NULL)
		{
			return GetLastError();
		}
		// 򿪷
		shMyService = OpenService(shServiceManager, _T("VernoxService"), SERVICE_ALL_ACCESS);
		if(shMyService == NULL)
		{
			nRet = GetLastError();
			if (nRet == ERROR_SERVICE_DOES_NOT_EXIST)
			{
ServiceInstallService_Lable:
				//ע
				STARTUPINFO si;
				PROCESS_INFORMATION pi;
				TCHAR lpPath[MAX_PATH];

				bInstall = TRUE;
				ZeroMemory(&pi, sizeof(pi));
				ZeroMemory(&si, sizeof(si));
				si.cb = sizeof(si);
				memset(lpPath, 0, MAX_PATH * sizeof(TCHAR));

				_stprintf(lpPath, _T("%sVernoxService.exe"), m_lpWorkingDir);
				CreateProcess(lpPath, _T("-Service"), NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
				Sleep(200);
				if(pi.hProcess == NULL)
				{
					return -1;
				}

				nCount = 0;
				while(TRUE)
				{
					shMyService = OpenService(shServiceManager, _T("VernoxService"), SERVICE_ALL_ACCESS);
					if(shMyService != NULL)
						break;
					if(WaitForSingleObject(pi.hProcess, 16) == WAIT_OBJECT_0)
					{
						break;
					}
					//1Ӿͷ
					if(nCount > 4000)
					{
						break;
					}
					nCount++;
				}
				CloseHandle( pi.hProcess );
				CloseHandle( pi.hThread );
				if(shMyService == NULL)
				{
					//Ϣʧ
					CloseServiceHandle(shServiceManager);
					return GetLastError();
				}
			} 
			else
			{
				return nRet;
			}	
		}

		if (!QueryServiceStatus(shMyService, &ssStatus)) //ѯصǰService״̬
		{
			CloseServiceHandle(shMyService);
			CloseServiceHandle(shServiceManager);
			return GetLastError();
		}

		if(ssStatus.dwCurrentState != SERVICE_RUNNING)
		{
			StartService(shMyService, 0, NULL);
			Sleep(200);
			//ʼѯ
			nCount = 0;
			while(TRUE)
			{
				QueryServiceStatus(shMyService, &ssStatus);
				if(ssStatus.dwCurrentState == SERVICE_RUNNING)
				{
					break;
				}
				else if(ssStatus.dwCurrentState == SERVICE_STOPPED)
				{
					if(bInstall)
					{
						CloseServiceHandle(shMyService);
						CloseServiceHandle(shServiceManager);
						return MF_FAILED;
					}
					else
					{
						DeleteService(shMyService);
						CloseServiceHandle(shMyService);
						CloseServiceHandle(shServiceManager);
						goto ServiceInstallService_Lable;
					}
				}
				Sleep(100);
				//1Ӿͷ
				if(nCount > 600)
				{
					break;
				}
			}
		}
		CloseServiceHandle(shMyService);
		CloseServiceHandle(shServiceManager);
		return MF_OK;
	}
	catch(...)
	{
		return MF_INNER_EXPCETION_FAILED;
	}
	return MF_OK;
}

void CSobeyMemDBConfigurationDlg::CreateDatabaseThread(LPVOID data)
{
	CSobeyMemDBConfigurationDlg *pDlg = (CSobeyMemDBConfigurationDlg *)data;
	CoInitialize(NULL);
	try
	{
		if(pDlg->m_pServerStatusManage != NULL)
		{
			delete pDlg->m_pServerStatusManage;
			pDlg->m_pServerStatusManage = NULL;
		}
		//аť״̬û
		pDlg->GetDlgItem(IDC_BTN_CREATE_DATABASE)->EnableWindow(FALSE);
		pDlg->GetDlgItem(IDC_BTN_CLOSE_DATABASE)->EnableWindow(FALSE);
		pDlg->GetDlgItem(IDC_BTN_START_DATABASE)->EnableWindow(FALSE);
		pDlg->GetDlgItem(IDC_BTN_DELETE_DATABASE)->EnableWindow(FALSE);
		//ݿ
		pDlg->CreateDatabaseCore();
		if(pDlg->m_pServerStatusManage != NULL)
		{
			delete pDlg->m_pServerStatusManage;
			pDlg->m_pServerStatusManage = NULL;
		}
	}
	catch (...)
	{
	}
	//аť״̬ÿ
	g_pEeventStart->SetEvent();
	pDlg->GetDlgItem(IDC_BTN_CREATE_DATABASE)->EnableWindow(TRUE);
	pDlg->GetDlgItem(IDC_BTN_CLOSE_DATABASE)->EnableWindow(TRUE);
	pDlg->GetDlgItem(IDC_BTN_START_DATABASE)->EnableWindow(TRUE);
	pDlg->GetDlgItem(IDC_BTN_DELETE_DATABASE)->EnableWindow(TRUE);
	CoUninitialize();
	_endthread();
}

void CSobeyMemDBConfigurationDlg::CreateDatabaseCore()
{
	CreateNewDatabase();
}
void CSobeyMemDBConfigurationDlg::OnTimer(UINT_PTR nIDEvent)
{
	int nRet;
	if(m_nProgress == 0)
	{
	}
	else
	{
		if(m_pServerStatusManage == NULL)
		{
			m_pServerStatusManage = new CServerStatusManage;
			nRet = m_pServerStatusManage->Initialize();
			if(nRet != MF_OK)
			{
				delete m_pServerStatusManage;
				m_pServerStatusManage = NULL;
			}
		}
		if(m_pServerStatusManage != NULL)
		{
			int nProgress;
			long long nFileSize, nLoadSize;
			nFileSize = 0;
			nLoadSize = 0;
			if(m_bFileNO == 0)
			{
				m_pServerStatusManage->UpdateFileStatus(m_bFileNO);
			}
			if(m_bFileNO != 0)
			{
				nRet = m_pServerStatusManage->GetFileProgressStatus(m_bFileNO, nFileSize, nLoadSize);
				if(nRet == MF_OK)
				{
					nProgress = m_nProgress + (nLoadSize * 90.0/(1024*1024)) / m_nTotalSize;
					m_ctlProgress.SetPos(nProgress);
				}
				else
				{
					m_bFileNO = 0;
				}
			}
		}
	}

	CDialog::OnTimer(nIDEvent);
}
