﻿/*
 *    Copyright (C) 2017 Sobey Inc.
 *
 *    This program is free software: you can redistribute it and/or  modify
 *    it under the terms of the GNU Affero General Public License, version 3,
 *    as published by the Free Software Foundation.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Affero General Public License for more details.
 *
 *    You should have received a copy of the GNU Affero General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#pragma once

class  CReadRedoLog
{
public:
	CReadRedoLog(void);
	virtual ~CReadRedoLog(void);

private:
	static char m_lpFilePath[MAX_PATH];

public:
	//int ClusterDataSync(LPBYTE lpBufferCache, int nBufferCacheSize, LPBYTE lpTempBuffer, int nTempBufferSize, LONGLONG llTimestamp);
	static void SetRedoDir(char* lpFilePath);
	static BOOL ReleaseRedoProcess(LPREDOPROCESS pRedoProcess);

	static BOOL InitRedoProcess(LPREDOPROCESS pRedoProcess);
	static int ReadRedoLog(LPREDOPROCESS pRedoProcess, LPBYTE lpBuffer, int nBufferSize, int& nDataLen);
	static int ReadExecutePlanHead(LPREDOPROCESS pRedoProcess, BASEEXECUTEPLANHEAD &stBaseExecutePlanHead);
	static int SetRedoID(LPREDOPROCESS pRedoProcess, LPBYTE lpBuffer, int nBufferSize, LONGLONG llTimestamp, int nRedoLogMaxID);
	static int SetRedoPointer(LPREDOPROCESS pRedoProcess, LPBYTE lpBuffer, int nBufferSize, LONGLONG llTimestamp);
	static int OpenRedoNew(LPREDOPROCESS pRedoProcess);
	static int CheckRedoUpdate(LPREDOPROCESS pRedoProcess);
	static int GetLastTimestamp(LONGLONG &llTimestamp);

	static long long RedoGetFileSize(FILE *fp);
};