﻿/*
 *    Copyright (C) 2017 Sobey Inc.
 *
 *    This program is free software: you can redistribute it and/or  modify
 *    it under the terms of the GNU Affero General Public License, version 3,
 *    as published by the Free Software Foundation.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Affero General Public License for more details.
 *
 *    You should have received a copy of the GNU Affero General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
// stdafx.cpp : 只包括标准包含文件的源文件
// SobeyMemServiceLib.pch 将作为预编译头
// stdafx.obj 将包含预编译类型信息

#include "stdafx.h"

//从LPMATHEXPELEMENTBSON中获取字段值
int GetDataValue(LPMATHEXPELEMENTBSON lpMathElementBson, VARDATA& stuVarData)
{
	switch(lpMathElementBson->m_bDataType)
	{
	case MF_VARDATA_NULL:
		stuVarData.m_vt = MF_VARDATA_NULL;
		break;
	case MF_VARDATA_INT:
		stuVarData.SetData(*(int*)(lpMathElementBson->m_bDataBuffer));
		break;
	case MF_VARDATA_INT64:
		stuVarData.SetData(*(long long*)(lpMathElementBson->m_bDataBuffer));
		break;
	case MF_VARDATA_DOUBLE:
		stuVarData.SetData(*(double*)(lpMathElementBson->m_bDataBuffer), MF_VARDATA_DOUBLE);
		break;
	case MF_VARDATA_DATE:
		stuVarData.SetData(*(double*)(lpMathElementBson->m_bDataBuffer), MF_VARDATA_DATE);
		stuVarData.m_vt = MF_VARDATA_DATE;
		break;
	case MF_VARDATA_STRING:
		stuVarData.SetData(lpMathElementBson->m_bDataBuffer, lpMathElementBson->m_nDataLen);
		break;
	case MF_VARDATA_BINARY:
		stuVarData.SetBinaryData((LPBYTE)lpMathElementBson->m_bDataBuffer, lpMathElementBson->m_nDataLen);
		break;
	case MF_VARDATA_UNKNOWN:
		stuVarData.SetData(lpMathElementBson->m_bFieldNo);
		break;
	}
	return MF_OK;
}

//去掉百分号
void RemovePercent(char* pStr, int nLen, VARDATA& varData)
{
	int nTempLen;
	char* pTempStr;

	nTempLen = nLen - 1;
	pTempStr = pStr;
	varData.m_bParam1 = 0;
	varData.m_bParam2 = 0;
	while(pTempStr[0] == MF_OPERATOR_PERCENT || pTempStr[0] == MF_OPERATOR_UNDERLINE)
	{
		if(pTempStr[0] == MF_OPERATOR_UNDERLINE)
		{
			varData.m_bParam1 = 2;
		}
		else if(varData.m_bParam1 == 0)
		{
			varData.m_bParam1 = 1;
		}
		nTempLen--;
		pTempStr++;
	}

	while(pTempStr[nTempLen - 1] == MF_OPERATOR_PERCENT || pTempStr[nTempLen - 1] == MF_OPERATOR_UNDERLINE)
	{
		if(pTempStr[nTempLen - 1] == MF_OPERATOR_UNDERLINE)
		{
			varData.m_bParam2 = 2;
		}
		else if(varData.m_bParam2 == 0)
		{
			varData.m_bParam2 = 1;
		}
		nTempLen--;
	}
	varData.SetData(pStr, nLen);
}

//设置临界资源值
void SetCriticalValue(LPVOID pSrc, LPVOID pDest, int nSize, LPCRITICAL_SECTION lpCritical, LPEXECUTEPLANBSON lpExecutePlan)
{
	CExecutePlanCriticalPtr cs(lpCritical, lpExecutePlan);
	memcpy(pSrc, pDest, nSize);
}	

//获取临界资源值
void GetCriticalValue(LPVOID pSrc, long long& nValue, int nSize, LPCRITICAL_SECTION lpCritical, LPEXECUTEPLANBSON lpExecutePlan)
{
	nValue = 0;
	CExecutePlanCriticalPtr cs(lpCritical, lpExecutePlan);
	memcpy(&nValue, pSrc, nSize);
}