/*
 *    Copyright (C) 2017 Sobey Inc.
 *
 *    This program is free software: you can redistribute it and/or  modify
 *    it under the terms of the GNU Affero General Public License, version 3,
 *    as published by the Free Software Foundation.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Affero General Public License for more details.
 *
 *    You should have received a copy of the GNU Affero General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// MainTabObjectIndex.cpp : ʵļ
//

#include "stdafx.h"
#include "SobeyMemTool.h"
#include "SobeyMemToolDlg.h"
#include "MainTabObjectIndex.h"
//#include "MainTabObject.h"
//#include "MainTabObjectIndex.h"


// CMainTabObjectIndex Ի

IMPLEMENT_DYNAMIC(CMainTabObjectIndex, CDialog)

CMainTabObjectIndex::CMainTabObjectIndex(CWnd* pParent /*=NULL*/)
	: CDialog(CMainTabObjectIndex::IDD, pParent)
{
	m_nRow = 0;
	m_nCol = 0;
	m_nExistedCount = -1;
}

CMainTabObjectIndex::~CMainTabObjectIndex()
{
}

void CMainTabObjectIndex::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_OBJECT, m_listObject);
	DDX_Control(pDX, IDC_EDIT_TEMP, m_editTemp);
	DDX_Control(pDX, IDC_COMBO_TEMP, m_cbTemp);
}

BOOL CMainTabObjectIndex::OnInitDialog()
{
	CDialog::OnInitDialog();

	//ʼؼ
	m_listObject.SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES | LVS_EX_INFOTIP);

	m_listObject.InsertColumn(0, _T(""), LVCFMT_LEFT, 20);
	m_listObject.InsertColumn(1, _T(""), LVCFMT_LEFT, 100);
	m_listObject.InsertColumn(2, _T("ֶ"), LVCFMT_LEFT, 100);
	m_listObject.InsertColumn(3, _T(""), LVCFMT_LEFT, 100);
	m_listObject.InsertColumn(4, _T("ṹ"), LVCFMT_LEFT, 100);
	m_listObject.InsertColumn(5, _T("洢ļ"), LVCFMT_LEFT, 100);

	m_listObject.InsertItem(0, _T("."));

	m_editTemp.ShowWindow(SW_HIDE);
	m_cbTemp.ShowWindow(SW_HIDE);

	return TRUE;
}

BEGIN_MESSAGE_MAP(CMainTabObjectIndex, CDialog)
	ON_NOTIFY(NM_CLICK, IDC_LIST_OBJECT, &CMainTabObjectIndex::OnNMClickListObject)
	ON_EN_KILLFOCUS(IDC_EDIT_TEMP, &CMainTabObjectIndex::OnEnKillfocusEditTemp)
	ON_CBN_KILLFOCUS(IDC_COMBO_TEMP, &CMainTabObjectIndex::OnCbnKillfocusComboTemp)
	ON_WM_SIZE()
END_MESSAGE_MAP()


// CMainTabObjectIndex Ϣ

void CMainTabObjectIndex::AddItem(CString strFirstColValue)
{
	int nColumnCount = m_listObject.GetItemCount();

	m_listObject.InsertItem(nColumnCount, strFirstColValue);
}

void CMainTabObjectIndex::DeleteItem()
{
	int i, nColumnCount;
	nColumnCount = m_listObject.GetItemCount();
	//ɾһ
	//if (nColumnCount <= 1)
	//{
	//	return;
	//}

	for (i = 0; i < nColumnCount; i++) 
	{ 
		if (m_listObject.GetItemState(i, LVIS_SELECTED) == LVIS_SELECTED)		//iбѡ
		{
			m_listObject.DeleteItem(i);
			m_nExistedCount--;
		}
	}
}

void CMainTabObjectIndex::SetExistedCount(int nCount)
{
	m_nExistedCount = nCount;
}

//////////////////////////////////////////////////////////////////////////

void CMainTabObjectIndex::OnNMClickListObject(NMHDR *pNMHDR, LRESULT *pResult)
{
	*pResult = 0;

	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<NMITEMACTIVATE*>(pNMHDR);

	NM_LISTVIEW* pNMListView=(NM_LISTVIEW*)pNMHDR;
	CRect rc;
	m_nRow = pNMListView->iItem;		//ѡе  
	m_nCol = pNMListView->iSubItem;		//ѡ 

	if (m_nRow == -1 || m_nCol == 0 || m_nRow < m_nExistedCount)
	{
		return;
	}

	if (m_nCol == 1)		//༭ 
	{  
		m_listObject.GetSubItemRect(m_nRow, m_nCol, LVIR_LABEL, rc);		//RECT 
		m_editTemp.SetParent(&m_listObject);								//תΪбе
		m_editTemp.MoveWindow(rc);											//ƶEditRECTڵλ 
		m_editTemp.SetWindowText(m_listObject.GetItemText(m_nRow, m_nCol));	//еֵEditؼ  
		m_editTemp.ShowWindow(SW_SHOW);										//ʾEditؼ  
		m_editTemp.SetFocus();												//Edit
		m_editTemp.ShowCaret();												//ʾ
		m_editTemp.SetSel(-1);												//ƶ
	}
	else if (m_nCol == 3 || m_nCol == 4 || m_nCol == 5)		//
	{
		m_listObject.GetSubItemRect(m_nRow, m_nCol, LVIR_LABEL, rc);		//RECT
		m_cbTemp.SetParent(&m_listObject);									//תΪбе
		m_cbTemp.MoveWindow(rc);											//ƶEditRECTڵλ
		m_cbTemp.SetWindowText(m_listObject.GetItemText(m_nRow, m_nCol));	//еֵEditؼ		//û
		m_cbTemp.ShowWindow(SW_SHOW);										//ʾEditؼ
		m_cbTemp.SetFocus();												//Edit

		m_cbTemp.ResetContent();
		if (m_nCol == 3)
		{
			m_cbTemp.AddString(_T("primarykey"));
			m_cbTemp.AddString(_T("unique"));
			m_cbTemp.AddString(_T("common"));
		}
		else if (m_nCol == 4)
		{
			m_cbTemp.AddString(_T("KV"));
			m_cbTemp.AddString(_T("BTree"));
		}
		else if (m_nCol == 5)
		{
			CSobeyMemToolDlg *pParent;
			pParent = (CSobeyMemToolDlg*)GetParent()->GetParent()->GetParent()->GetParent();

			int nFileType, nIndexStructure;
			CString strFile, strIndexStructure;
			list<STRUCT_FILEINFO>::iterator iter;
			list<STRUCT_FILEINFO>* plistFileInfo;

			strIndexStructure = m_listObject.GetItemText(m_nRow, 4);
			if (strIndexStructure.CompareNoCase(_T("KV")) == 0)
			{
				nIndexStructure = MF_SYS_FILETYPE_KVINDEXFILE;
			}
			else if (strIndexStructure.CompareNoCase(_T("BTree")) == 0)
			{
				nIndexStructure = MF_SYS_FILETYPE_TREEINDEXFILE;
			}
			else if (strIndexStructure.CompareNoCase(_T("")) == 0)
			{
				nIndexStructure = 0;
			}
			else
			{
				nIndexStructure = -1;
			}

			plistFileInfo = &(pParent->m_listFileInfo);
			for (iter = plistFileInfo->begin(); iter != plistFileInfo->end(); iter++)
			{
				nFileType = ((STRUCT_FILEINFO)*iter).m_nFileType;
				/*if (nFileType == MF_SYS_FILETYPE_DATAFILE)
				{
					strFile.Format(_T("DATAFILE '%s'"), ((STRUCT_FILEINFO)*iter).m_strFileName);
				}
				else */if (nFileType == MF_SYS_FILETYPE_TREEINDEXFILE && (nIndexStructure == MF_SYS_FILETYPE_TREEINDEXFILE || nIndexStructure == 0))
				{
					strFile.Format(_T("TREEFILE '%s'"), ((STRUCT_FILEINFO)*iter).m_strFileName);
					m_cbTemp.AddString(strFile);
				}
				else if (nFileType == MF_SYS_FILETYPE_KVINDEXFILE && (nIndexStructure == MF_SYS_FILETYPE_KVINDEXFILE || nIndexStructure == 0))
				{
					strFile.Format(_T("KVFILE '%s'"), ((STRUCT_FILEINFO)*iter).m_strFileName);
					m_cbTemp.AddString(strFile);
				}
				else
				{
					continue;
				}
			}
		}
	}
	else if (m_nCol == 2)				//ѡֶ
	{
		CMainTabObject *pParent;
		pParent = (CMainTabObject*)GetParent()->GetParent();

		int nCount;
		CString* arrayStrText;

		nCount = pParent->m_dlgMainTabObjectField.m_listObject.GetItemCount();
		if (nCount > 0)
		{
			arrayStrText = new CString[nCount];
			for (int i = 0; i < nCount; i++)
			{
				arrayStrText[i] = pParent->m_dlgMainTabObjectField.m_listObject.GetItemText(i, 1);
			}

			m_dlgMainTabObjectIndexSelect.SetInitData(arrayStrText, nCount, &m_listObject, m_nRow, m_nCol, TRUE);
			m_dlgMainTabObjectIndexSelect.DoModal();
			delete[] arrayStrText;
		} 
		else
		{
			m_dlgMainTabObjectIndexSelect.SetInitData(NULL, 0, &m_listObject, m_nRow, m_nCol, TRUE);
			m_dlgMainTabObjectIndexSelect.DoModal();
		}
	}
	//else if (m_nCol == 5)
	//{
	//	CSobeyMemToolDlg *pParent;
	//	pParent = (CSobeyMemToolDlg*)GetParent()->GetParent()->GetParent()->GetParent();

	//	int nCount, i;
	//	int nFileType;
	//	CString strFile;
	//	CString* arrayStrText;
	//	list<STRUCT_FILEINFO>::iterator iter;
	//	list<STRUCT_FILEINFO>* plistFileInfo;

	//	plistFileInfo = &(pParent->m_listFileInfo);
	//	nCount = plistFileInfo->size();
	//	if (nCount > 0)
	//	{
	//		i = 0;
	//		arrayStrText = new CString[nCount];
	//		for (iter = plistFileInfo->begin(); iter != plistFileInfo->end(); iter++)
	//		{
	//			nFileType = ((STRUCT_FILEINFO)*iter).m_nFileType;
	//			if (nFileType == MF_SYS_FILETYPE_DATAFILE)
	//			{
	//				strFile.Format(_T("DATAFILE '%s'"), ((STRUCT_FILEINFO)*iter).m_strFileName);
	//			}
	//			else if (nFileType == MF_SYS_FILETYPE_TREEINDEXFILE)
	//			{
	//				strFile.Format(_T("TREEFILE '%s'"), ((STRUCT_FILEINFO)*iter).m_strFileName);
	//			}
	//			else if (nFileType == MF_SYS_FILETYPE_KVINDEXFILE)
	//			{
	//				strFile.Format(_T("KVFILE '%s'"), ((STRUCT_FILEINFO)*iter).m_strFileName);
	//			}
	//			else
	//			{
	//				nCount--;
	//				continue;
	//			}

	//			arrayStrText[i] = strFile;
	//			i++;
	//		}

	//		m_dlgMainTabObjectIndexSelect.SetInitData(arrayStrText, nCount, &m_listObject, m_nRow, m_nCol, FALSE);
	//		m_dlgMainTabObjectIndexSelect.DoModal();
	//		delete[] arrayStrText;
	//	} 
	//	else
	//	{
	//		m_dlgMainTabObjectIndexSelect.SetInitData(NULL, 0, &m_listObject, m_nRow, m_nCol, FALSE);
	//		m_dlgMainTabObjectIndexSelect.DoModal();
	//	}
	//}
}

void CMainTabObjectIndex::OnEnKillfocusEditTemp()
{
	CString strTemp;  
	m_editTemp.GetWindowText(strTemp);						//õûµ  
	m_listObject.SetItemText(m_nRow, m_nCol, strTemp);		//ñ༭  
	m_editTemp.ShowWindow(SW_HIDE);							//ر༭ 
}

void CMainTabObjectIndex::OnCbnKillfocusComboTemp()
{
	CString strTemp;  
	m_cbTemp.GetWindowText(strTemp);						//õûµ
	if (strTemp != _T(""))
	{
		m_listObject.SetItemText(m_nRow, m_nCol, strTemp);	//ñ༭ 
	} 
	m_cbTemp.ShowWindow(SW_HIDE);							//ر༭ 
}
void CMainTabObjectIndex::OnCancel()
{
	//CDialog::OnCancel();
}

void CMainTabObjectIndex::OnOK()
{
	//CDialog::OnOK();
}

void CMainTabObjectIndex::OnSize(UINT nType, int cx, int cy)
{
	CRect rtCtrl, rtClient;
	CDialog::OnSize(nType, cx, cy);

	//ƶڴС
	GetClientRect(rtClient);
	m_listObject.GetWindowRect(rtCtrl);
	ScreenToClient(rtCtrl);
	rtCtrl.right = rtClient.right - 2;
	rtCtrl.bottom = rtClient.bottom - 2;
	m_listObject.SetWindowPos(NULL, 0, 0, rtCtrl.Width(), rtCtrl.Height(), SWP_NOMOVE | SWP_NOZORDER);
}
